#include <syslib/types.h>
#include <syslib/env.h>

#include <libhs/strings.h>
#include <libhs/output.h>

#include "banner.h"

void ClassicHello(void)
{
  PrintLn("Hello, world !");
}

void BannerHello(void)
{
  GenBanner("Hello, world !");
}

static void PrintHelp(void)
{
  PrintLn(
    "Prints a greeting and exits.\n\n"
    "Usage: hello [-b]\n\n"
    "-b\tGenerate the greeting as a banner (surrounded by stars)"
  );
}

static void PrintVersion(void)
{
/*
#--- JVS KEYCHAR CONTROL BLOCK BEGIN -------------
#DEFCHAR # MODVERSION
#DEFCHAR $ MODREVISION " [revision %d]"
#DEFCHAR : TIME "Y-m-d"
#DEFCHAR ! TIME "H:i:s"
#REPLACE ON
#--- JVS KEYCHAR CONTROL BLOCK END ---------------
*/
  PrintLn("OSHS hello, version #$ (: !)");
/*
#--- JVS KEYCHAR CONTROL BLOCK BEGIN -------------
#REPLACE OFF
#--- JVS KEYCHAR CONTROL BLOCK END ---------------
*/
}

static void PrintLicensingInfo(void)
{
  PrintLn(
    "This program is free software; you can (re)distribute it and/or\n"
    "modify it under the terms of the GNU General Public License as\n"
    "published by the Free Software Foundation; either version 3 of\n"
    "the License, or (at your option) any later version.\n"
    "\n"
    "This program is distributed in the hope that it will be useful,\n"
    "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
    "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the\n"
    "GNU General Public License for more details.\n"
    "\n"
    "You should have received a copy of the GNU General Public License\n"
    "along with this program; if not, contact the Free Software\n"
    "Foundation, Inc."
  );
}

int16 Main(void)
{
  const char *Arg;

  Arg=GetArg(0);
  if (Arg==NULL) {
    ClassicHello();
  } else if (StrCmp(Arg,"-b")==0) {
    BannerHello();
  } else if (StrCmp(Arg,"--help")==0) {
    PrintHelp();
  } else if (StrCmp(Arg,"--version")==0) {
    PrintVersion();
  } else if (StrCmp(Arg,"--license")==0) {
    PrintLicensingInfo();
  } else {
    PrintLn("Unrecognized argument. Try '--help' for more info.");
  }
  return(0);
}
