#include <syslib/types.h>
#define __INTERFACE__
#include "devices.h"

#include <syslib/kernel.h>
#include <syslib/pdbase.h>
#include <syslib/pdfsys.h>

#include "servers.h"
#include "errno.h"

static bool DoFindDevice(int8 Cmd,TDevInfoReply *R)
{
  TNoParamCmd C;
  TServerInfo I;
  bool Result;

  C.Command=Cmd;
  I.Server=hndDEVICES;
  I.Cmd=&C;
  I.CmdSize=sizeof(C);
  I.Reply=R;
  I.RepSize=sizeof(*R);
  Result=SendCmd(&I);
  if (Result) {
    if (I.RepSize==0) {
      R->Type=dtInvalid;
    }
  }
  return(Result);
}

bool FindFirstDevice(TDevInfoReply *R)
{
  return(DoFindDevice(cmdFindFirstDevice,R));
}

bool FindNextDevice(TDevInfoReply *R)
{
  return(DoFindDevice(cmdFindNextDevice,R));
}

int16 OpenFirstDeviceOfType(TDeviceType Type)
{
  TDevInfoReply R;
  TOpenDeviceCmd C;
  TOpenDeviceReply OR;
  TServerInfo I;

  if (!FindFirstDevice(&R)) return(-1);
  while (R.Type!=dtInvalid) {
    if (R.Type==Type) {
      C.Command=cmdOpenDevice;
      C.Device=R.ID;
      I.Server=hndDEVICES;
      I.Cmd=&C;
      I.CmdSize=sizeof(C);
      I.Reply=&OR;
      I.RepSize=sizeof(OR);
      if (!SendCmd(&I)) return(-1);
      return(OR.Handle);
    }
    if (!FindNextDevice(&R)) return(-1);
  }
  SetErrNo(fseNODEV);
  return(-1);
}
