#include <syslib/types.h>
#include <syslib/env.h>

#include <libhs/exec.h>
#include <libhs/memory.h>
#include <libhs/output.h>
#include <libhs/errno.h>

int16 Main(void)
{
  uint16 ArgCnt;
  int16 Result;

  ArgCnt=GetArgCnt();
  if (ArgCnt==0) {
    Print(
      "usage: OSHS <program> <arg1> <arg2> ... <argN>\n"
      "\n"
      "Executes an OSHS binary specified by <program> with arguments "
      "specified by\n"
      "the <arg1> through <argN> arguments\n"
      "\n"
    );
    return(1);
  }
  Result=Call((void *)GetArgs(),NULL);
  if (Result<0) {
    Print("Could not execute ");
    Print(GetArg(0));
    Print("\nThe system said: ");
    ComplainLastError();
    return(1);
  }
  return(Result);
}
