#include <syslib/hhead.h>
#ifndef __h__LIBHS_GFXCON__
#define __h__LIBHS_GFXCON__

#include <syslib/kernel.h>
#include <syslib/pdfsys.h>
#include <syslib/pdgfxcon.h>

/*
  Flags
*/
#define flgSoftScreen	32768
#define flgGraphics	16384
#define flgAllFlags	(flgSoftScreen+flgGraphics)
/*
  Pixel sizes
*/
#define lPixelSize	12
#define mPixelSize      (3<<lPixelSize)
#define px8bit	0
#define px16bit	1
#define px24bit	2
#define px32bit	3
/*
  Resolutions
*/
#define lWidth		6
#define mWidth          (63<<lWidth)
#define lHeight		0
#define mHeight         (63<<lHeight)
#define num100		0
#define num160		1
#define num200		2
#define num320		3
#define num350		4
#define num400		5
#define num480		6
#define num600		7
#define num640		8
#define num768		9
#define num800		10
#define num960		11
#define num1024		12
#define num1280		13

/*
  Color information structure.
*/
typedef struct {
  uint16 R;
  uint16 G;
  uint16 B;
} TColor;

/*
  Informations about the currently selected video mode.
*/
extern pubconst uint16 CurHeight;
extern pubconst uint16 CurWidth;
extern pubconst uint8 CurBitsPerPixel;

/*
  Pointer to mapped video memory of the currently set mode. This pointer may
  be changed by the mode setting call.
*/
extern pubconst void *VideoMemory;

/*
  Routines
*/
void UnpackModeNumber(uint16 Mode,TSetModeCommand *C);
int16 SetScreenMode(uint16 Mode);
int16 SetScreenModeByRes(uint16 Width,uint16 Height,uint8 BPP,uint8 Flags);
void OpenScreenRegion(uint16 X,uint16 Y,uint16 Width,uint16 Height);
void ScreenWrite(void *Buffer,uint32 Size);
void UpdateScreen(void);
bool EnsureKeyboardIsOpen(void);
uint16 RawReadKey(void);
void CloseKeyboard(void);

#endif
#include <syslib/hfoot.h>
