#include <syslib/types.h>
#define __INTERFACE__
#include "libman.h"

#include <syslib/env.h>
#include <syslib/kernel.h>

#include "strings.h"

static char *GetDirectory(
  const char *EnvVarName,
  const char *DefaultValue,
  char *Buffer,
  uint16 Size
)
{
  const char *Ptr;
  char *WPtr;
  char Ch;

  Ptr=GetEnv(EnvVarName);
  if (Ptr==NULL) Ptr=DefaultValue;
  WPtr=StrNCpy(Buffer,Ptr,Size);
  Ch=*(WPtr-1);
  if ((Ch!='\\' && Ch!='/') && (WPtr<Buffer+Size)) {
    *(WPtr++)='/';
    if (WPtr<Buffer+Size) *WPtr='\0';
  }
  return(WPtr);
}

/*** Get the directory where the programs are being installed ***/
char *GetBinaryDirectory(char *Buffer,uint16 Size)
{
  return(GetDirectory("OSHSPROGRAMS","Z:/BIN",Buffer,Size));
}

/*** Get the directory where the nonexec libraries are being installed ***/
char *GetNonexecLibraryDirectory(char *Buffer,uint16 Size)
{
  return(GetDirectory("OSHSLIBRARIES","Z:/LIB",Buffer,Size));
}

/*** Get the directory where the libraries are being installed ***/
char *GetHeaderDirectory(char *Buffer,uint16 Size)
{
  return(GetDirectory("OSHSHEADERS","Z:/INCLUDE",Buffer,Size));
}

/*** Place the extension of binaries ***/
char *PutBinaryExtension(char *Buffer,bool UseDot)
{
  const char *BinExt;

  BinExt=KCFG__BINARY_EXTENSION();
  if (BinExt==NULL) BinExt="bcf";
  if (UseDot) {
    if (*BinExt!='\0') {
      *(Buffer++)='.';
    }
  }
  return(StrCpy(Buffer,BinExt));
}
