#include <syslib/types.h>
#define __INTERFACE__
#include "numconv.h"

#include "strings.h"
#include "numconvi.h"
#include "errno.h"

void FormatDWord(uint32 Num, uint16 Places, char Filler, char *Ptr)
{
  char Str[11];

  assert(Places<=10);
  MemSet(Str,10,Filler);
  FormatDWordCore(Num,Str+11);
  MemCpy(Ptr,Str+10-Places,Places+1);
}

void FormatHex(
  uint32 Num,
  uint16 Places,
  bool DownCase,
  char Filler,
  char *Ptr
)
{
  char Str[9];

  assert(Places<=8);
  MemSet(Str,8,Filler);
  FormatHexCore(Num,Str+9,DownCase);
  MemCpy(Ptr,Str+8-Places,Places+1);
}

uint32 DecToU32(const char *Ptr)
{
  uint32 Result;
  char Ch;
  bool Valid;

  SetErrNo(0);
  Result=0;
  Ch=*(Ptr++);
  Valid=Ch!='\0';
  while (Valid && Ch!='\0') {
    Result*=10;
    Result+=(Ch-'0');
    Ch=*(Ptr++);
    Valid=(Ch=='\0' || (Ch>='0' && Ch<='9'));
  }
  if (!Valid) {
    SetErrNo(lheINVNUM);
    Result=0xFFFFFFFF;
  }
  return(Result);
}

int32 DecToI32(const char *Ptr)
{
  bool Negative;
  bool Valid;
  uint32 AbsVal;
  int32 Result;

  Negative=(*Ptr=='-');
  if (Negative) Ptr++;
  AbsVal=DecToU32(Ptr);
  Valid=GetErrNo()==0;
  if (Valid) {
    if (Negative) {
      Valid=AbsVal<=0x80000000;
    } else {
      Valid=AbsVal<=0x7FFFFFFF;
    }
  }
  if (Valid) {
    if (Negative) {
      Result=-AbsVal;
    } else {
      Result=AbsVal;
    }
  }
  if (!Valid) {
    SetErrNo(lheINVNUM);
    Result=-1;
  }
  return(Result);
}
