#include <syslib/types.h>
#define __INTERFACE__
#include "strings.h"

#include <syslib/strtools.h>

#include "memory.h"

void *StrCpy(void *Dest,const void *Source)
{
  return(STR__strcpy(Dest,Source));
}

void *StrDup(const void *Source)
{
  uint16 Len;
  char *Mem;

  Len=STR__strlen(Source);
  Mem=GetMem(Len+1);
  if (Mem) STR__memcpy(Mem,Source,Len+1);
  return(Mem);
}

void *StrNCpy(void *Dest,const void *Source,uint16 Size)
{
  return(STR__strncpy(Dest,Source,Size));
}

int16 StrCmp(const void *s1,const void *s2)
{
  return(STR__strcmp(s1,s2));
}

int16 StrNCmp(const void *s1,const void *s2,uint16 Size)
{
  return(STR__strncmp(s1,s2,Size));
}

uint16 StrLen(const void *Str)
{
  return(STR__strlen(Str));
}

void *MemCpy(void *Dest,const void *Src,uint16 Size)
{
  return(STR__memcpy(Dest,Src,Size));
}

void *MemMove(void *Dest,const void *Src,uint16 Size)
{
  return(STR__memmove(Dest,Src,Size));
}

void *MemSet(void *Dest,uint16 Size,uint8 Byte)
{
  return(STR__memset(Dest,Size,Byte));
}

int16 MemCmp(const void *Buf1,const void *Buf2,uint16 Size)
{
  return(STR__memcmp(Buf1,Buf2,Size));
}

void *StrChr(const void *Str,char c)
{
  return(STR__strchr(Str,c));
}

void *StrRChr(const void *Str,char c)
{
  return(STR__strrchr(Str,c));
}

char UpCase(char Ch)
{
  return(STR__upcase(Ch));
}

void *StrToUpr(void *Dest,const void *Src)
{
  return(STR__strtoupr(Dest,Src));
}

void *StrNToUpr(void *Dest,const void *Src,uint16 Size)
{
  return(STR__strntoupr(Dest,Src,Size));
}

char DownCase(char Ch)
{
  return(STR__downcase(Ch));
}

void *StrToLwr(void *Dest,const void *Src)
{
  return(STR__strtolwr(Dest,Src));
}

void *StrNToLwr(void *Dest,const void *Src,uint16 Size)
{
  return(STR__strntolwr(Dest,Src,Size));
}

char SwapCase(char Ch)
{
  if (((Ch&0xDF)>='A') && ((Ch&0xDF)<='Z')) Ch^=(char)32;
  return(Ch);
}

void *StrSwapCase(void *Dest,const void *Src)
{
  const char *S;
  char *D;
  char Ch;

  S=Src;
  D=Dest;
  do {
    Ch=*(S++);
    *(D++)=SwapCase(Ch);
  } while (Ch);
  return(D-1);
}

void *StrNSwapCase(void *Dest,const void *Src,uint16 Size)
{
  const char *S;
  char *D;
  char Ch;

  S=Src;
  D=Dest;
  do {
    Size--;
    Ch=*(S++);
    *(D++)=SwapCase(Ch);
  } while (Ch && (Size));
  return(D-(Ch=='\0'));
}
