#include <syslib/types.h>
/*
  Test: Date and time packing, unpacking and printing.
*/

#include "../output.h"
#include "../datetime.h"

void FormatAndPrint(const char *Format,uint32 TimeStamp)
{
  char Buffer[40];
  
  if (TimeStamp==0xFFFFFFFF) {
    Print("Bad");
  } else {
    Print("[");
    PrintNum(TimeStamp,10);
    Print("]=");
    FormatTimeStamp(Format,TimeStamp,Buffer);
    Print(Buffer);
  }
}

void TestDate(int16 Year,int16 Month,int16 Day)
{
  TDateTime T;
  T.Year=Year;
  T.Month=Month;
  T.Day=Day;
  T.Hour=0;
  T.Minute=0;
  T.Second=0;
  PackTimeStamp(&T);
  FormatAndPrint("d-m-Y",T.TimeStamp);
}

void TestTime(int16 Year,int16 Month,int16 Day,int16 Hour,int16 Minute,int16 Sec)
{
  TDateTime T;

  T.Year=Year;
  T.Month=Month;
  T.Day=Day;
  T.Hour=Hour;
  T.Minute=Minute;
  T.Second=Sec;
  PackTimeStamp(&T);
  FormatAndPrint("d-m-Y H:i:s",T.TimeStamp);
}

int16 Main(void)
{
  int16 i;

  for (i=1970;i<1974;i++) {
    TestDate(i,1,1);
    Print(" ");
    TestDate(i,12,31);
    NewLine();
  }
  for (i=1996;i<2012;i++) {
    TestTime(i,2,28,23,59,59);
    Print(" ");
    TestTime(i,2,29,0,0,0);
    NewLine();
    TestTime(i,3,1,0,0,0);
    NewLine();
  }
  return(0);
}
