#include <syslib/hhead.h>
#ifndef __h__OBS_ERRORS__
#define __h__OBS_ERRORS__

typedef struct tagMessage {
  char Class;
  uint16 Line;
  uint16 Column;
  const char *Text;
  const char *Args[3];
  const struct tagMessage *Next;
} TMessage;

typedef bool TMessageHook(const TMessage *Msg);

extern pubconst TMessage * pubconst First;
extern TMessageHook *MsgHook;
extern pubconst bool OutOfMmemory;
extern pubconst uint16 ErrorCount;

void InitErrors(void);
void ReportOutOfMemory(void);

const char *Number2Text(uint16 Number);

void SetupFileName(const char *FileName);
void PushFileName(void);
void PopFileName(void);

void PutArg(const char *Arg);
void PutNumArg(uint16 Number);
void ClearMessages(void);

void Fatal(const char *Msg);

bool DumpMsg(const TMessage *Msg);

void ReportError(uint16 Line,uint16 Column,const char *Msg);
void ReportWarning(uint16 Line,uint16 Column,const char *Text);

void PlainError(const char *Msg);
void FileError(const char *Msg);
void SysError(const char *Msg);
void TokError(const char *Msg);

bool CheckIOResultAndReport(const char *Msg);

#endif
#include <syslib/hfoot.h>
