#include <syslib/types.h>
#include <libhs/output.h>
#include <libhs/filebuf.h>

#include "args.h"
#include "errors.h"
#include "fileext.h"
#include "pkgdata.h"
#include "dop.h"
#include "pkgscan.h"
#include "pkgdeps.h"
#include "pkginst.h"
#include "pkgclean.h"
#include "mkmod.h"

static void InitializeSystem(void)
{
  InitErrors();
  MsgHook=DumpMsg;
  InitExtensions();
  InitFiles();
}

int16 Main(void)
{
  int16 CurrentErrors;
  TPackage *P;
  TBufferedFile *F;

  InitializeSystem();
  if (!AnalyzeArgs()) return(1);
  P=FindPackageDescription();
  if (P==NULL) return(2);
  if (ModuleName[0]=='\0') {
    F=ReleaseInputFile();
    ReadDepTree(P);
    CurrentErrors=ErrorCount;
    SetupInputFile(F);
  }
  if (!ParsePackageDescription(P)) return(3);
  if (ModuleName[0]!='\0') MkMod(P);
  if (ErrorCount>CurrentErrors) return(4);
  if (ModuleName[0]!='\0') return(0);
  ScanPackage(P);
  if (ClearDirectory) {
    CleanPackage(P);
  } else {
    WriteDepTree(P);
    if (InstallThings) InstallPackage(P);
  }
  return(0);
}
