#include <syslib/types.h>
#define __INTERFACE__
#include "scanmain.h"

/*
  File scanner main module

  This module contains the routinne which takes a filename and invokes the
  proper driver to capture its dependencies and (optionally) to compile it.
  This is not easy since some file types need a translator to be built before
  the dependencies can be captured.
*/

#include <libhs/strings.h>

#include "errors.h"
#include "fileread.h"
#include "fileext.h"
#include "files.h"
#include "scanbase.h"
#include "scancp.h"
#include "dop.h"

void ScanFile(TFileInModule *F)
{
  const char *Ext;

  if (PrepareFileForScan(F)) {
    Ext=F->Ext->Ext;
    if (StrCmp(Ext,"c")==0) {
      ScanCCompatiblePSource();
    } else if (StrCmp(Ext,"h")==0) {
      ScanCCompatiblePHeader();
    } else {
      FileError("Unknown extension");
    }
    FinalizeFileAfterScan();
  }
}
