#include <syslib/types.h>
#include <syslib/traps.h>
#include <syslib/kernel.h>
#include <syslib/pdkeys.h>
#include <syslib/pdgfxcon.h>

#include <libhs/strings.h>
#include <libhs/gfxcon.h>

#include "settings.h"
#include "errors.h"
#include "screen.h"
#include "bench.h"
#include "menu.h"
#include "scrmode.h"
#include "fbvideo.h"
#include "misc.h"

staticdatablock(MainMenu)
  streami8u mitItem endstream
  streamstr "Choose screen mode" endstream
  streamptr ChooseMode endstream

  streami8u mitSubMenu endstream
  streamstr "Framebuffer screen tests" endstream
  streamptr FramebufferMenu() endstream

  streami8u mitSubMenu endstream
  streamstr "Miscellaneous tests" endstream
  streamptr MiscMenu() endstream

  streami8u mitEndMarker endstream
enddatablock

int16 Main(void)
{
  /*
    Setup some useful defaults
  */
  ScrMode=(num800<<lWidth)+(num600<<lHeight)+(px16bit<<lPixelSize);
  TestDuration=20;
  /*
    Set the video mode
  */
  if (!SetTheScreenMode()) Fatal("Unable to set video mode");
  InitializeBenchmarking();
  ClearScreen();
  RunMenu(MainMenu());
  return(0);
}
