#include <syslib/types.h>
#define __INTERFACE__
#include "misc.h"

#include "menu.h"
#include "settings.h"
#include "screen.h"
#include "keytest.h"

static void ShowTable(void)
{
  int16 xx,yy;
  int16 XSpacer,YSpacer;
  int16 XSize,YSize;
  int16 i,j;
  char Ch[2];

  /*
    Determine the spaces between the characters
  */
  XSpacer=2;
  if (ScrWidth>320) XSpacer++;
  if (ScrWidth>640) XSpacer++;
  YSpacer=1;
  if (ScrHeight>200) YSpacer++;
  if (ScrHeight>400) YSpacer++;
  if (ScrHeight>=800) YSpacer++;
  /*
    Determine the location of the table on the screen
  */
  XSize=XSpacer*15+1;
  YSize=YSpacer*5+1+3;
  xx=(ScrWidth/8-XSize)/2;
  yy=(ScrHeight/16-YSize)/2;
  /*
    Draw the character table
  */
  Ch[0]=' ';
  Ch[1]='\0';
  for (i=0;i<6;i++) {
    for (j=0;j<16;j++) {
      PrintXY(xx+j*XSpacer,yy+i*YSpacer+3,16+14,Ch);
      Ch[0]++;
    }
  }
  /*
    Draw the "Hello, world" label
  */
  PrintXY(xx+(XSize-16)/2,yy,78," Hello, world ! ");
  /*
    Wait to a key from the keyboard
  */
  ReadKey();
}

datablock(MiscMenu)
  streami8u mitItem endstream
  streamstr "Testing character table" endstream
  streamptr ShowTable endstream

  streami8u mitItem endstream
  streamstr "Keyboard test" endstream
  streamptr TestKeyboard endstream

  streami8u mitEndMarker endstream
enddatablock
