#! /bin/sh

. ./findecho.sh
. ./findm4.sh
for FILE in tests/*.m4; do

  # Output the message for the user
  echo "Check: $FILE"

  # Determine the name of the output file
  TEMP="$IFS"
  IFS="."
  LAST=""
  DOT=""
  OUTF=""
  for C in $FILE; do
    OUTF="$OUTF$LAST"
    LAST="$DOT$C"
    DOT="."
  done
  IFS="$TEMP"
  ACTO=$OUTF.os
  ACTE=$OUTF.es
  ERRF=$OUTF.err
  LOGF=$OUTF.log
  OUTF=$OUTF.out

  # Generate the output of the test
  echo "debugfile(\`')dnl" >check1.tmp
  echo "define(\`GPS_TESTING')dnl" >>check1.tmp
  echo "m4_debugfile([$LOGF])" >check2.tmp
  rm -f $LOGF
  echo "m4trace: -1- id 1: debugfile ..." >check.err
  echo "m4trace: -1- id 1: debugfile(\`') -> ???" >>check.err
  if test -f $ERRF; then
    cat $ERRF >>check.err
  fi

  . ./mkscript.sh "-dtaeqcx check1.tmp" "check2.tmp $FILE" >$ACTO 2>$ACTE

  # Check if the output is correct
  OKAY=:
  if diff -Nu $OUTF $ACTO; then :; else
    OKAY=false
  fi
  if diff -u check.err $ACTE; then :; else
    OKAY=false
  fi
  if $OKAY; then
    rm -f $ACTO $ACTE $LOGF
  fi
done
rm -f check.err check1.tmp check2.tmp
