#! /bin/sh

# If user requested cleanup, do so
if test "x$1" = "xclean"; then
  rm -f config.gen config.log results.gen scansys.gen
  exit 0
fi

# Determine how to execute suscripts with arguments
export SH_EXEC=`sh ./findexec.sh`

# Check how to suppress automatic newline in "echo" command.
. ./findecho.sh

# Build the platform scanner. This action can be supressed by passing the
# "leavescanner" string as an argument.
if test "x$1" != "xleavescanner"; then
  $SH_EXEC ./buildgps.sh
fi

# If only scanner rebuild was requested, exit now.
if test "x$1" = "xbuildscanner"; then
  rm -f gpslist.m4
  exit 0
fi

# Display a messae saying that the shell execution environment is being
# initialized. The shell execution environment initialization is long
# enough to merit such a status message. We must emit the message with the
# trailing newline since the discovery how to suppress it is made during
# the shell execution environment initialization itself. This must be done
# here since the platform scanner can pass itself to a diferent interpreter
# which results in the line to be printed more than once in such a case. The
# generated platform scanner is not working on its own so placing the message
# here will not hurt.
echo "initializing the shell execution environment"

# Execute the platform scanner script just generated.
rm -f results.gen
sh ./scansys.gen
