FGNone  =       256
BGNone  =       512
EmptyAttr =     FGNone+BGNone

List=[
  # standard window text attributes
  1*16+11,
  # Code window colors
  BGNone+11,    # string content
  BGNone+12,    # quotes
  BGNone+15,    # builtin macros
  BGNone+14,    # user defined macros
  BGNone+10,    # control codes
  BGNone+13,    # argument expressions
  BGNone+13,
]

StandardWindowText=0
CodeStrings=1
CodeQuotes=2
CodeBuiltins=3
CodeMacros=4
CodeControl=5
CodeArgExp=6
CodeDeleted=7

def Combine(Base,Mask):
  """
  Combine two colors Base and Mask. Base is the color being modified and Mask
  specifies how to modify Base. The "present" color components of Mask
  will replace corresponding components in Base. Components of Base that are
  "missing" in Mask are left intact.
  """
  if not(Mask & FGNone):
    Base&=~(0x0F+FGNone)
    Base+=Mask & 0x0F
  if not(Mask & BGNone):
    Base&=~(0xF0+BGNone)
    Base+=Mask & 0xF0
  return(Base)
