import termio
import colors
import sys
import m4debug

HOST="localhost"
PORT=8888
CodeWinSize=30

try:
  execfile("m4debug.lcf")
except IOError:
  pass

def BuildWindows(T):
  global DispCode
  T.SetColor(colors.StandardWindowText)
  T.DrawRect(1,1,120,CodeWinSize)
  DispCode=[]

def BuildIndent(Indent):
  return [(colors.StandardWindowText,' ')]*Indent

def Str2Disp(L,Color,String):
  for Ch in String:
    L.append((Color,Ch))

def SendStr(L,String):
  Str2Disp(L,colors.CodeQuotes,'"')
  for Ch in String:
    if Ch<'\x20':
      Color=colors.CodeControl
      Ch=chr(ord(Ch)+ord('A')-1)
    elif Ch>'\x7E' and Ch<'\xA0':
      Color=colors.CodeControl
      Ch=chr(ord(Ch)-128+ord('a')-1)
    elif Ch>='\xA0':
      Color=colors.CodeControl
      Ch='?'
    else:
      Color=colors.CodeStrings
    L.append((Color,Ch))
  Str2Disp(L,colors.CodeQuotes,'"')

def FlushLine(Indent):
  global Line
  if not Line:
    return
  L=BuildIndent(Indent)
  SendStr(L,Line)
  DispCode.append(L)
  Line=''

def DisplayInstruction(Inst,Indent):
  global Line
  if type(Inst) is type(""):
    Line+=Inst
  elif type(Inst) is type([]):
    Line+=m4debug.QuoteL+m4debug.UnparseQuotes(Inst)+m4debug.QuoteR
  elif type(Inst) is type(()):
    FlushLine(Indent)
    L=BuildIndent(Indent)
    Name=Inst[0]
    try:
      Exp=m4debug.GetMacroDefinition(Name)
    except KeyError:
      Exp=None
    Color=colors.CodeMacros
    if type(Exp) is type(()):
      Color=colors.CodeBuiltins
    if Exp is None:
      Color=colors.CodeDeleted
    Str2Disp(L,Color,Name)
    if Inst[3]:
      Str2Disp(L,colors.StandardWindowText,"()")
    if Inst is m4debug.ParsedInput[0]:
      if m4debug.Expanding==0:
        Phrase="Collecting"
      elif m4debug.Expanding==1:
        Phrase="Expanding"
      elif m4debug.Expanding==2:
        Phrase="Argument substitution"
        if m4debug.CurrentArg>=len(Inst[3]):
          Phrase=("Expanded")
      else:
        Phrase=None
      if not Phrase is None:
        Str2Disp(L,colors.StandardWindowText,' ('+Phrase+')')
    DispCode.append(L)
    ArgList=Inst[3]
    Exp=m4debug.Expanding
    if not Inst is m4debug.ParsedInput[0] or Exp is None:
      Exp=0
    if Exp==0:
      BuildCodeForDisplay(ArgList,Indent+2)
      FlushLine(Indent+2)
    elif Exp==1:
      L=BuildIndent(Indent+2)
      Str2Disp(L,colors.StandardWindowText,"$#=")
      SendStr(L,str(len(ArgList)))
      DispCode.append(L)
      ArgNum=1
      for Arg in ArgList:
        L=BuildIndent(Indent+2)
        Str2Disp(L,colors.StandardWindowText,"$%d="%ArgNum)
        SendStr(L,Arg)
        DispCode.append(L)
        ArgNum+=1
    else:
      Arg=0
      for Item in ArgList:
        if type(Item) is type(()):
          L=BuildIndent(Indent+2)
          Str2Disp(L,colors.CodeArgExp,"$"+Item[0])
          DispCode.append(L)
        else:
          if Arg or Item or len(ArgList)==1:
            L=BuildIndent(Indent+2)
            SendStr(L,Item)
            DispCode.append(L)
        Arg=1-Arg

def BuildCodeForDisplay(Code,Indent):
  for Inst in Code:
    if len(DispCode)>=CodeWinSize:
      break
    DisplayInstruction(Inst,Indent)

def ShowCode():
  global Line
  Line=""
  if not DispCode:
    m4debug.ParseInputString()
    BuildCodeForDisplay(m4debug.ParsedInput,0)
    FlushLine(0)
    while len(DispCode)<CodeWinSize:
      DispCode.append([])
  LastColor=None
  for Line in xrange(CodeWinSize):
    Term.GotoXY(1,Line+1)
    L=DispCode[Line]
    X=0
    for Color,Char in L:
      if Color!=LastColor:
        Term.SetColor(Color)
        LastColor=Color
      Term.Write(Char)
      X+=1
      if X==120:
        break
    Term.SetColor(colors.StandardWindowText)
    LastColor=colors.StandardWindowText
    Term.WriteRep(" ",120-X)

def SingleStep():
  m4debug.SingleStep()
  DispCode[:]=[]
  ShowCode()

Term=termio.Connect(HOST,PORT)
BuildWindows(Term)
m4debug.InstallM4Input(sys.argv[1:])
m4debug.InitializeM4()
ShowCode()
while 1:
  Key=Term.ReadKey()
  if Key==termio.ESC:
    break
  SingleStep()
  if not m4debug.Stack and not m4debug.ParsedInput:
    break
else:
  Term.ReadKey()
Term.Close()
