# Character Ranges for 'sed'
#
# These macros are used whenever a 'sed' scripts wants to build a regular
# expression that matches to letters or digits or something similar. We
# cannot use [A-Z] etc, since some old Russian machines or some strange
# machines designed by Microsoft (such as XBox) may have character ranges
# broken. So we better avoid depending on these character ranges.

GPS_DEFCHECK([AS_CR_letters],[DNL[
  ]TST_RESULT[='abcdefghijklmnopqrstuvwxyz'
]])

GPS_DEFCHECK([AS_CR_LETTERS],[DNL[
  ]TST_RESULT[='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
]])

GPS_DEFCHECK([AS_CR_DIGITS],[DNL[
  ]TST_RESULT[='0123456789'
]])

GPS_DEFCHECK([AS_CR_Letters],[DNL[
  ]TST_RESULT[=]AS_CR_letters[]AS_CR_LETTERS[
]])

GPS_DEFCHECK([AS_CR_ALNUM],[DNL[
  ]TST_RESULT[=]AS_CR_Letters[]AS_CR_DIGITS[
]],[
  # PATH needs CR, and LINENO needs CR and PATH.
  # Also some other stuff needs CR.
  # Avoid depending upon Character Ranges.
])
