# Generic Platform Scanner for OSHS SYSLIB.
# The main script of the library
#
# The Generic Platform Scanner for OSHS SYSLIB (or 'GPS') is a M4/shell
# program that is used to scan the platform on which the SYSLIB library is
# being built.

# The m4 initialization script, 'm4init.m4', is NOT included here. It must be
# specified on commandline before this file. The reason is the m4 debugger,
# which does the initializations in its own manner and thus does not need
# 'm4init.m4' file to do these initializations for it. See the 'm4init.m4'
# file for more details.

# Additional macros for the m4 enviroment
m4_include([src/m4sugar.m4])

# The check declaration related macros for GPS
m4_include([src/gpstests.m4])

# Send the prologue of the script
m4_ifdef([GPS_TESTING],[],[m4_divert(0)])dnl
#! /bin/sh

# Guess values for system dependent variables and configure the SYSLIB build
# process accordingly.
#
# This script is automatically generated by the General Platform Scanner
# program, namely the 'config' program located inside it.
# !!! DO NOT EDIT !!!
#
# The General Platform Scanner is a part of SYSLIB library.
#
# The SYSLIB library is free software; you are welcome to (re)distribute
# it and/or modify under the GNU General Public License as published by
# the Free Software Foundation, either the version 2 of the License or
# (at your option) any later version.
#
# The SYSLIB library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
# Public License for more details.
m4_divert(-1)
