# Log file creation and initialization
#
# The log file is created and initialized by various values determined by
# the GPS checks. If GPS makes a mistake, this file can be consulted.

GPS_DEFSNIPPET([GPS_OPEN_LOG],[[
  # Create the logfile and output general informations into it.
  exec 5>]SH_SELFDIR[/config.log
  cat >&5 <<EOF
  This file contains any messages produced by compilers while
  running GPS, to aid debugging if GPS makes a mistake.

  It was created by ]SH_SELF[, which was
  generated by OSHSGPS 1.00.  Invocation command line was

    $ @S|@0 @S|@@

  ## --------- ##
  ## Platform. ##
  ## --------- ##

  hostname = `(hostname || uname -n) 2>/dev/null | sed 1q`
  uname -m = `(uname -m) 2>/dev/null || echo unknown`
  uname -r = `(uname -r) 2>/dev/null || echo unknown`
  uname -s = `(uname -s) 2>/dev/null || echo unknown`
  uname -v = `(uname -v) 2>/dev/null || echo unknown`

  /usr/bin/uname -p = `(/usr/bin/uname -p) 2>/dev/null || echo unknown`
  /bin/uname -X     = `(/bin/uname -X) 2>/dev/null     || echo unknown`

  /bin/arch              = `(/bin/arch) 2>/dev/null              || echo unknown`
  /usr/bin/arch -k       = `(/usr/bin/arch -k) 2>/dev/null       || echo unknown`
  /usr/convex/getsysinfo = `(/usr/convex/getsysinfo) 2>/dev/null || echo unknown`
  hostinfo               = `(hostinfo) 2>/dev/null               || echo unknown`
  /bin/machine           = `(/bin/machine) 2>/dev/null           || echo unknown`
  /usr/bin/oslevel       = `(/usr/bin/oslevel) 2>/dev/null       || echo unknown`
  /bin/universe          = `(/bin/universe) 2>/dev/null          || echo unknown`

  EOF
  {
    as_save_IFS=$IFS; IFS=]SH_PATH_SEPARATOR[
    for as_dir in $PATH
    do
      IFS=$as_save_IFS
      test -z "$as_dir" && as_dir=.
      echo "PATH: $as_dir"
    done
  } >&5
  cat >&5 <<EOF

  ## ------------------- ##
  ## Reports from checks ##
  ## ------------------- ##

  EOF
]])

GPSL_DEFPIECE_NOINDENT([GPS_START_LOG],[[
  exec 6>&1 >&5
  ]SH_ECHO_N[ "LINE $LINENO: "
]])

GPSL_DEFPIECE_NOINDENT([GPS_STOP_LOG],[[
  exec 1>&6
]])

GPSL_DEFPIECE_NOINDENT([GPS_LOG],[[
  echo "LINE $LINENO: $1" >&5
]])
