# Detecting how to link against SDL
#
# SDL is a nonstandard library used to interface with multimedia (audio,
# video, CDROM etc) in a platform-independent way. Since it is nonstandard,
# it is not available until we ask for it - and we need to know how to ask
# for it.

GPS_DEFCHECK_C([GPSL_PROBE_SDL],[[
#include <SDL/SDL.h>
int main(void)
{
  void *p;
  p=SDL_Init;
  if (p!=printf) {
    printf("yes");
  }
  return(0);
}
]])

GPS_DETECT_LIBRARY([SDL],
  [SDL library],[[
  ]TST_RESULT[="no"
  if (sdl-config --libs || exit 1) >/dev/null 2>&1; then
    GPS_CURLIB=`sdl-config --libs`
    if ]GPS_IS_HEADER([SDL/SDL.h])[; then
      ]GPSL_PROBE_SDL[
      if test "x]CODE_OUTPUT[" = "xyes"; then
        ]TST_RESULT[="yes"
      fi
    fi
  fi
]])
