# Detecting the X11 library
#
# X11 is most often found at UNIX-like systems like GNU or BSD. However it
# may be possible to have it ported to some other non-UNIX operating systems
# although the probability of that is awfully small.

GPS_DEFCHECK_C([GPSL_PROBE_X11],[[
#include <X11/Xlib.h>
int main(void)
{
  void *p;
  p=XOpenDisplay;
  if (p!=printf) {
    printf("yes");
  }
  return(0);
}
]])

GPS_DETECT_LIBRARY([X11],
  [X11 library],[[
  ]GPS_ARE_HEADERS([X11/Xlib.h,X11/Xutil.h,])[
  if test "x$]TST_RESULT[" = "xyes"; then
    GPS_CURLIB="-L/usr/X11R6/lib -lX11"
    ]GPSL_PROBE_X11[
    if test -z "]CODE_OUTPUT["; then
      GPS_CURLIB="-L/usr/lib -lX11"
      ]GPSL_PROBE_X11[
    fi
    if test -z "]CODE_OUTPUT["; then
      ]TST_RESULT[="no"
    fi
  fi
]])
