# Setup the shell for Bourne compatibility
#
# The 'zsh' and 'bash' shells have some of the default behavior incompatible
# with original bourne shell so they need to be reconfigured a bit. The 'ksh'
# shells have bugs that affect the configuration script and may cause it to
# make a mistake. All these problems are addressed by these code snippets

GPS_DEFSNIPPET([SH_SETUP_BOURNE],[[
  # Be Bourne compatible
  if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
    emulate sh
    NULLCMD=:
    # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
    # is contrary to our usage.  Disable this feature.
    alias -g '${1+"$@"}'='"$@"'
  elif test -n "${BASH_VERSION+set}" && (set -o posix) >/dev/null 2>&1; then
    set -o posix
  fi
  DUALCASE=1; export DUALCASE # for MKS sh
]])

GPS_DEFSNIPPET([SH_KSH_BUGFIX],[[
  # Work around bugs in pre-3.0 UWIN ksh.
  ]SH_UNSET[ ENV MAIL MAILPATH
  PS1='$ '
  PS2='> '
  PS4='+ '
]])
