# Intelligent file linking
#
# This checks for symbolic ling support and uses symlinks or hardlinks when
# they are supported (symlinks are preferred). Otherwise the files are simply
# copied. Creating links is much faster than copying files around; therefore
# this feature is sometimes called "fast copy".

GPS_DEFCHECK([SH_FASTCP],[[
  # Intelligent file linking. The files are linked when the links are
  # supported by the platform, otherwise they are simply copied.
  rm -f conftmp conftmp.exe conftmp.tmp
  echo >conftmp.tmp
  if ln -s conftmp.tmp conftmp 2>/dev/null; then
    # We could just check for DJGPP; but this test a) works b) is more generic
    # and c) will remain valid once DJGPP supports symlinks (DJGPP 2.04).
    if test -f conftmp.exe; then
      # Don't use ln at all; we don't have any links
      ]TST_RESULT[='cp -p'
    else
      ]TST_RESULT[='ln -s'
    fi
  elif ln conftmp.tmp conftmp 2>/dev/null; then
    ]TST_RESULT[=ln
  else
    ]TST_RESULT[='cp -p'
  fi
  rm -f conftmp conftmp.exe conftmp.tmp
]])
