# Detect whether 'mkdir -p' is supported
#
# The 'mkdir -p' creates the directory along with any nonexistent
# intermediate directories. It is convenient, however not all systems support
# it. Avoid bogus error messages if not supported (there is another but
# slower way to do that).

GPS_DEFCHECK([SH_MKDIR_P],[[
  # Check for 'mkdir -p' support. The 'mkdir -p' creates the directory and
  # all its parents that don't exist yet.
  if mkdir -p . 2>/dev/null; then
    ]TST_RESULT[=:
  else
    test -d ./-p && rmdir ./-p
    ]TST_RESULT[=false
  fi
]])
