# The 'unset' builtin presence detection.
#
# Not all shells have the 'unset' builtin. This check detects if the shell
# executing us has 'unset'. If not, arranges things that failure exit code of
# the command will be returned without distorting the output of the script
# with error messages about nonexistent 'unset' command (and confusing the
# user with that).

GPS_DEFCHECK([SH_UNSET],[[
  # Support unset when possible.
  if ( (MAIL=60; unset MAIL) || exit) >/dev/null 2>&1; then
    ]TST_RESULT[=unset
  else
    ]TST_RESULT[=false
  fi
]])
