# Determine how to change owner/group. If available, fchown() will be used
# for this purpose. If not available, chown() will be used (fchown() is
# preferred since it does not contain a race condition). On platforms without
# these system calls some sort of reduced implementation is selected.

GPS_CHECK_FUNCTION([fchown],[
  #include <sys/types.h>
  #include <unistd.h>
])

GPS_DEFEXCL([CHOWN],
  [how to implement chown() and chgrp()],[[
  ]GPS_ARE_HEADERS([sys/types.h,unistd.h,])[
  if test "x]GPS_HAVE_FCHOWN[" != "xyes"; then
    ]TST_RESULT[="no"
  fi
  if test "x]GPS_HAVE_DIRFD[" != "xyes"; then
    ]TST_RESULT[="no"
  fi
  if test "x$]TST_RESULT[" = "xyes"; then
    ]TST_RESULT[="secure"
  else
    ]TST_RESULT[="posix"
  fi
  case "]GPS_PLATFORM[" in
    *-mingw32 | *-cygwin | *-msdosbc)
      ]TST_RESULT[="root_only"
    ;;
  esac
]])
