# Select whether to enable workaround for the "right alt bug". On some
# platforms the "right alt" key is reported as "mode shift". This workaround
# converts the "mode shift" keystrokes to "right alt" keystrokes.
#
# This version enables this workaround on any pc machine, which is identified
# by the "pc" being the second thing inn the platform ID tuple (when the
# tuple has four elements and the third one is "pc", this also triggers this
# workaround to be enabled but I guess there are no such tuples as I don't
# known about a kernel named "pc" (the third component of a four-component
# platform tuple is the name of the kernel) and when the SDL screen driver is
# used. The "pc" machines have no "mode shift" key and non-SDL screen drivers
# don't use the result of this test.

GPS_DEFBOOL([ALT_BUG],
  [whether to enable the 'right alt bug' workaround],[[
  ]GPS_UNUSED[
  if ]GPS_TEST_LIB_SDL[; then
    ]TST_RESULT[="no"
    case "]GPS_PLATFORM[" in
      *-pc-*-*)
        ]TST_RESULT[="yes"
      ;;
    esac
  fi
]])
