# Check whether some standard headers and functions are present. If they are
# not there, abort the process, giving a nice error message.

GPS_CHECK_FUNCTION([malloc],[
  #include <stdlib.h>
])
GPS_CHECK_FUNCTION([free],[
  #include <stdlib.h>
])
GPS_CHECK_FUNCTION([exit],[
  #include <stdlib.h>
])

GPS_DEFCHECKING([GPS_C_STD_HEADERS],[we have all required standard headers],[[
  ]GPS_ARE_HEADERS([stdio.h,stdlib.h,string.h,])[
  if test "x]GPS_HAVE_MALLOC[" != "xyes"; then
    ]TST_RESULT[="no"
  fi
  if test "x]GPS_HAVE_FREE[" != "xyes"; then
    ]TST_RESULT[="no"
  fi
  if test "x]GPS_HAVE_EXIT[" != "xyes"; then
    ]TST_RESULT[="no"
  fi
]])

GPS_DEFSNIPPET([GPS_C_CHECK_STANDARD_HEADERS_PRESENT],[[
  # Ensure all headers we are using during bootstrap and early compilation
  # stages are in place. If some of them are missing, bail out and don't
  # bother to even probe further; most probing C code requires some or all of
  # these headers.
  if test "x]GPS_C_STD_HEADERS[" != "xyes"; then
    ]GPS_ERROR([Some of the headers required by the bootstrap are missing])[
  fi
]])
