# Check whether the 'readdir' call is broken. A broken readdir returns an
# error condition when it reaches the end of the directory list. This check
# is used only when POSIX readdir() driver is used as other drivers don't
# make use of this check.

GPS_DEFCHECK_C([GPSL_CHECK_READDIR_OPERATION],[[
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>

int DetectReaddirBroken()
{
  DIR *dd;
  struct dirent *D;

  dd=opendir(".");
  if (dd==NULL) return(1);
  do {
    errno=0;
    D=readdir(dd);
  } while (D!=NULL);
  return(errno!=0);
}

int main(void)
{
  const char *Msg;

  Msg="no";
  if (DetectReaddirBroken()) Msg="yes";
  printf(Msg);
  return(0);
}
]])

GPS_DEFBOOL([READDIR_BAD],
  [whether readdir is broken],[[
  ]GPS_UNUSED[
  if test "x]GPSC_DIR_MANIP[" = "xposix"; then
    ]TST_RESULT[="yes"
    ]GPSL_CHECK_READDIR_OPERATION[
    if test "x]CODE_OUTPUT[" = "xno"; then
      ]TST_RESULT[="no"
    fi
  fi
]])
