# Determines how to suspend execution of a process for a specified amount of
# time.

GPS_CHECK_FUNCTION([usleep],[
  #include <unistd.h>
])
GPS_CHECK_FUNCTION([select],[
  #include <sys/select.h>
])
GPS_CHECK_FUNCTION([nanosleep],[
  #include <time.h>
])

GPS_DEFEXCL([SLEEP_DRV],
  [for execution suspension driver],[[
  case "]GPS_PLATFORM[" in
    *-apollo-*)
      # Apollo sys5.3 has broken usleep(). It has select() too, but it's
      # time wait feature is also broken :-(
      # So we need to use a version based on time$wait there.
      ]TST_RESULT[="apollo"
    ;;
    *-mingw32 | *-cygwin)
      ]TST_RESULT[="windows"
    ;;
    *)
      if test "]GPS_HAVE_USLEEP[" = "yes"; then
        ]TST_RESULT[="usleep"
      elif test "]GPS_HAVE_SELECT[" = "yes"; then
        ]TST_RESULT[="select"
      elif ]GPS_IS_HEADER([poll.h])[; then
        ]TST_RESULT[="poll"
      elif ]GPS_IS_HEADER([sys/poll.h])[; then
        ]TST_RESULT[="syspoll"
      elif test "]GPS_HAVE_NANOSLEEP[" = "yes"; then
        ]TST_RESULT[="posix"
      else
        ]TST_RESULT[="sleep"
      fi
    ;;
  esac
]])
