# Check whether the target supports the O_SYNC flag to the open(). This flag
# must ensure that data are written to the device before the write() call
# writing to the resulting handle returns.

m4_define([HEADERS_NORMAL],[
#include <fcntl.h>
])

m4_define([HEADERS_IO],[
#include <io.h>
])


m4_define([THE_TEST_ITSELF],[
int main(void)
{
  if (O_SYNC != 0) {
    printf("yes");
  } else {
    printf("no");
  }
  return(0);
}
])

GPS_DEFCHECK_C([GPSL_CHECK_OPEN_WITH_NORMAL],[
]HEADERS_NORMAL[
]THE_TEST_ITSELF[
])

GPS_DEFCHECK_C([GPSL_CHECK_OPEN_WITH_IO],[
]HEADERS_IO[
]THE_TEST_ITSELF[
])

GPS_DEFBOOL([SYNC_SUPPORT],
  [whether open() supports O_SYNC flag],[[
  ]TST_RESULT[="no"
  if test "]GPSC_NEED_IO[" = "yes"; then
    ]GPSL_CHECK_OPEN_WITH_IO[
  else
    ]GPSL_CHECK_OPEN_WITH_NORMAL[
  fi
  if test -n "]CODE_OUTPUT["; then
    ]TST_RESULT[="]CODE_OUTPUT["
  fi
]])
