# Check whether we can use large static arrays in the library.
#
# The static arrays can expand up to 128 KB. If that much of static memory is
# not available, we need to turn on a switch that shrinks the various
# structures used to handle various things. This reduces usability but allows
# the OSHS code to commpile under constrained memory settings.

GPS_DEFCHECK_C([GPSL_DETECT_LARGE_DATA_SECTION],[[
char BigArray[128*1024];
int main(void)
{
  printf("yes");
  return(0);
}
]])

GPS_DEFBOOL_NEGATED([TIGHT_MEMORY],
  [whether we can use large static structures],[[
  ]GPSL_DETECT_LARGE_DATA_SECTION[
  if test "x]CODE_OUTPUT[" = "x"; then
    ]TST_RESULT[="no"
  else
    ]TST_RESULT[="]CODE_OUTPUT["
  fi
]])
