#ifndef __h__BUILDER_FILES__
#define __h__BUILDER_FILES__

#define MAX_FILE_STACKS 3

typedef struct tagTFileInfo {
  const char *FileName;
  struct tagTFileInfo *Source;
  struct tagTFileInfo **DepList;
  int DepCount;
  struct tagTFileInfo *StkNext[MAX_FILE_STACKS];
} TFileInfo;

bool CheckCorrect8dot3(const char *FileName);

void InitializeFiles(void);
TFileInfo *RegisterFile(const char *FileName);
bool RegisterFileToBeProcessed(TFileInfo *F);
TFileInfo *GetNextFileToBeProcessed(void);
void ReinitializeFileProcessingStack(void);

void InitFileAccessStack(void);
void RegisterAccessedFile(TFileInfo *F);
TFileInfo *GetNextAccessedFile(void);
void DestroyFileAccessStack(void);

void ActivateFile(TFileInfo *F);
bool RegisterDependencyFile(TFileInfo *F,bool Active);
void DeactivateFile(void);

TFileInfo *RegisterModuleIdentifiedByHeader(char *Name);

#endif
