#include <stdio.h>
#include <string.h>

#include "types.h"
#include "fileread.h"

static FILE *File;
static char FileName[128];

static void ReportFailure(const char *What)
{
  char Buffer[1024];
  char *Ptr;

  strcpy(Buffer,"Unable to ");
  Ptr=Buffer+strlen(Buffer);
  strcpy(Ptr,What);
  Ptr=Ptr+strlen(Ptr);
  *(Ptr++)=' ';
  *(Ptr++)='\'';
  strcpy(Ptr,FileName);
  Ptr=Ptr+strlen(Ptr);
  *(Ptr++)='\'';
  Fatal(Buffer);
}

void OpenOutputFile(const char *Name)
{
  strncpy(FileName,Name,127);
  FileName[127]='\0';
  File=fopen(Name,"wt");
  if (File==NULL) ReportFailure("open");
}

void PrintLen(const char *What,int Len)
{
  int Written;
  Written=fwrite(What,1,Len,File);
  if (Written!=Len) ReportFailure("write into");
}

void Print(const char *What)
{
  PrintLen(What,strlen(What));
}

void NewLine(void)
{
  PrintLen("\n",1);
}

void CloseOutputFile(void)
{
  if (fclose(File)==-1) {
    ReportFailure("close");
  }
}
