#include <stdlib.h>

#include "types.h"
#include "prepsym.h"
#include "files.h"
#include "scandop.h"
#include "preproc.h"
#include "genmkf.h"
#include "fileread.h"

int main(int argc,const char **argv)
{
  const char *Arg;
  int Verbose;

  Arg=argv[1];
  Verbose=Arg!=NULL && Arg[0]=='-' && Arg[1]=='v' && Arg[2]=='\0';
  WereErrors=false;
  InitializeFiles();
  ReadDescriptions();
  ReadDefinitions("../gps/config.gen","GPS generated configuration",true);
  ReadDefinitions("../config.usr",NULL,false);
  ReadPackageDescription("syslib.dop");
  AnalyzeFiles();
  if (WereErrors) return(1);
  WriteDefinitionsAsCCode();
  BuildMakefile(Verbose);
  return(0);
}
