#include "defs.gh"
#include "types.h"
#include "kernel.h"
#include "kernmsg.h"
#include "pdbase.h"
#include "pdfsys.h"
#include "pdfileio.h"
#include "diskdata.h"
#include "diskdumb.h"
#include "strings.h"
#include "memory.h"
#include "pddev.h"
#include "devmain.h"

#define __INTERFACE__
#include "disknull.h"
#undef __INTERFACE__

static int32 NullRead(void *fd,void *Buf,int32 Size)
{
  if (fd==Buf);
  if (Size==0);
  return(0);
}

static int32 ZeroRead(void *fd,void *Buf,int32 Size)
{
#if !__b__IO32__
  int16 Remaining;
  int16 TSize;
  upint8 *Ptr;
#endif

  if (fd==Buf);
#if __b__IO32__
  MemSet(Buf,Size,0);
#else
  Remaining=Size;
  Ptr=Buf;
  while (Remaining>0) {
    TSize=16384;
    if (Remaining<TSize) TSize=Remaining;
    MemSet(Ptr,TSize,0);
    Remaining-=TSize;
    Ptr+=TSize;
  }
#endif
  return(Size);
}

static int32 NullWrite(void *fd,const void *Buf,int32 Size)
{
  if (fd==Buf);
  return(Size);
}

static int16 OpenNullDevice(TOpenReport *R)
{
  void *Handle;
  TGenericFileHandle *H;

  Handle=CreateFileHandleData(sizeof(TGenericDeviceHandle));
  if (Handle==NULL) return(beNOMEM);
  H=Handle;
  R->Data=Handle;
  H->Read=NullRead;
  H->Write=NullWrite;
  return(0);
}

static int16 OpenZeroDevice(TOpenReport *R)
{
  void *Handle;
  TGenericFileHandle *H;

  Handle=CreateFileHandleData(sizeof(TGenericDeviceHandle));
  if (Handle==NULL) return(beNOMEM);
  H=Handle;
  R->Data=Handle;
  H->Read=ZeroRead;
  H->Write=NullWrite;
  return(0);
}

static int32 FullWrite(void *fd,const void *Buf,int32 Size)
{
  if (fd==Buf);
  return(fseNOSPC);
}

static int16 FullSeek(void *fd,int32 Where,int16 How)
{
  if (fd==NULL);
  if (Where==How);
  return(0);
}

static int16 OpenFullDevice(TOpenReport *R)
{
  void *Handle;
  TGenericFileHandle *H;

  Handle=CreateFileHandleData(sizeof(TGenericDeviceHandle));
  if (Handle==NULL) return(beNOMEM);
  H=Handle;
  R->Data=Handle;
  H->Read=ZeroRead;
  H->Write=FullWrite;
  H->Seek=FullSeek;
  return(0);
}

void AddNullFullZero(void)
{
  AddDevice(dtCharacter,"null",OpenNullDevice);
  AddDevice(dtCharacter,"full",OpenFullDevice);
  AddDevice(dtCharacter,"zero",OpenZeroDevice);
}
