#include "defs.gh"
#include "types.h"

#include "time.h"
#include "kernmsg.h"
#include "process.h"

#define __INTERFACE__
#include "kernel.h"
#undef __INTERFACE__

#include "thread.h"

/*
  The kernel configuration calls
*/
const char *KCFG__BINARY_EXTENSION(void)
{
#if __b__EASY_DEVEL__
#undef __t__RETURN_NULL__
#define __t__RETURN_NULL__ 0
#if __b__GNU_LINUX__
  return("");
#else
#undef __t__RETURN_NULL__
#define __t__RETURN_NULL__ 1
#endif
#else
#undef __t__RETURN_NULL__
#define __t__RETURN_NULL__ 1
#endif
#if __t__RETURN_NULL__
  return(NULL);
#endif
}

bool KCFG__SHARED_LIBRARIES_SUPPORTED(void)
{
#if __i__LIB_SUPPORT__shared__
  return(true);
#else
  return(false);
#endif
}


int16 KCALL__SYSINFO(TSystemInfo *Buffer)
{
  return(keNOTSUP);
}

int32 KCALL__MKCHAN(void)
{
  return(keNOTSUP);
}

int16 KCALL__SEND(int16 Channel,void *Message,int16 Size)
{
  return(SendCore(Channel,Message,Size));
}

int16 KCALL__RECV(int16 Channel,void *Message,uint16 Size,upint32 *Sender)
{
  return(RecvCore(Channel,Message,Size,Sender));
}

int16 KCALL__GIVEHND(int16 Handle, int16 ProcHandle)
{
  return(keNOTSUP);
}

int16 KCALL__CLOSE(int16 Handle)
{
  return(CloseCore(Handle));
}

int16 KCALL__MKPROC(uint32 DataSize)
{
  return(keNOTSUP);
}

int16 KCALL__MAP(int16 Process, int16 Region, uint32 Location, uint8 Access)
{
  return(keNOTSUP);
}

int16 KCALL__MKREG(void)
{
  return(keNOTSUP);
}

int16 KCALL__FILL(uint32 FirstPage, uint32 CountOfPages, int16 FillerByte)
{
  return(keNOTSUP);
}

int16 KCALL__EMPTY(uint32 FirstPage, uint32 CountOfPages)
{
  return(keNOTSUP);
}

int32 KCALL__MAPREGS(int16 ProcessHandle)
{
  return(keNOTSUP);
}

uint32 KCALL__GETTID(void)
{
  return(keNOTSUP);
}

void KCALL__SUSPEND(uint64 MicroSeconds)
{
  DelayThread(MicroSeconds);
}

void KCALL__HALT(uint8 ExitCode)
{
  PerformProgramHalting(ExitCode);
}

int16 KCALL__THRNEW(TMainFunction *MainFnc,void *Data,void *SP)
{
  if (SP!=NULL) return(keNOTSUP);
  return(SYSCreateNewThread(MainFnc,Data));
}

int16 KCALL__THRWAIT(int16 ThreadID)
{
  return(SYSWaitThread(ThreadID));
}

int16 KCALL__THRKILL(int16 ThreadID)
{
  return(SYSKillThread(ThreadID));
}

int32 KCALL__LOCKNEW(void)
{
  return(SYSCreateLock());
}

int16 KCALL__LOCK(int16 LockID)
{
  SYSLock(LockID);
  return(0);
}

int16 KCALL__UNLOCK(int16 LockID)
{
  SYSUnlock(LockID);
  return(0);
}

int16 KCALL__LOCKDEL(int16 LockID)
{
  return(SYSDestroyLock(LockID));
}

int32 KCALL__CONDNEW(void)
{
  return(SYSCreateCond());
}

int16 KCALL__SET(int16 CondID)
{
  SYSSetCond(CondID);
  return(0);
}

int16 KCALL__RESET(int16 CondID)
{
  SYSResetCond(CondID);
  return(0);
}

int16 KCALL__WAIT(int16 CondID)
{
  SYSWaitCond(CondID);
  return(0);
}

int16 KCALL__CONDDEL(int16 CondID)
{
  return(SYSDestroyCond(CondID));
}
