#ifndef __h__SYSLIB_KERNMSG__
#define __h__SYSLIB_KERNMSG__

typedef int16 TSendProc(void *PrivData, void *Message, int16 Size);
typedef int16 TRecvProc(void *PrivData, void *Message, int16 Size);
typedef int16 TCloseProc(void *PrivData);
typedef void TDestroyProc(void *PrivData);
typedef int16 THandler(void *Msg, int16 Size, void *Out, void *PrivateData);
typedef int16 TPostHandler(void *Out, void *PrivateData);

int16 DumbClose(void *PrivData);
void DumbDestroy(void *PrivData);

/*** The generic handle structure ***/
typedef struct tagTHandle {
  TSendProc *Send;
  TRecvProc *Recv;
  TCloseProc *Close;
  TDestroyProc *Destroy;
  void *PrivData;
} THandle;

void InitializeChannels(void);
void LockChannels(void);
void UnlockChannels(void);
int16 CreateChannelNoLock(void **Data);
int16 CreateChannel(void **Data);
void InitializeChannel(
  void *Channel,
  THandler *Handler,
  void *PrivateData,
  TCloseProc *Closer,
  TDestroyProc *Destroyer
);
void InstallPostHandler(void *Channel,TPostHandler *Handler);
void *GetPostHandler(void *Channel);
void *GetCurrentChannel(void);
int16 SendCore(int16 Channel,void *Message,int16 Size);
int16 RecvCore(int16 Channel,void *Message,uint16 BufSize,upint32 *Sender);
int16 CloseCoreNoLock(int16 Channel);
int16 CloseCore(int16 Channel);

#endif
