#ifndef __h__SYSLIB_LTARGS__
#define __h__SYSLIB_LTARGS__
#include "hhead.h"

extern privconst bool LinkSystemLibsStatic;

#if __b__TIGHT_MEMORY__
#define MAX_ARGUMENTS_SIZE 1024
#define MAX_ARGUMENT_COUNT 128
#else
#define MAX_ARGUMENTS_SIZE 32768
#define MAX_ARGUMENT_COUNT 4096
#endif

typedef struct tagTArgumentList {
  const char *ArgList[MAX_ARGUMENT_COUNT+1];
  char ArgBlock[MAX_ARGUMENTS_SIZE];
  char *ArgBlockPtr;
  const char **ArgListPtr;
  struct tagTArgumentList *Next;
} TArgumentList;

TArgumentList *CreateList(void);
char *AddArgument(TArgumentList *List,const char *Arg);
char *AddList(TArgumentList *List,const char *const*Args);
char *AddSystemLibraries(TArgumentList *List);
void DestroyArgumentLists(void);

#include "hfoot.h"
#endif
