#include "defs.gh"

#include <stdlib.h>

#include "types.h"
#include "conio.h"
#include "memcheck.h"

#define __INTERFACE__
#include "memory.h"
#undef __INTERFACE__

#include "typesnd.h"

void *KMEM__malloc(uint16 MemSize)
{
  CheckHeap();
  return(malloc(MemSize));
}

void *KMEM__hugemalloc(uint32 MemSize)
{
  CheckHeap();
#if !__b__HUGE_MEMORY__
  if (MemSize>65535) return(NULL);
#endif
  return(malloc(MemSize));
}

void *KMEM__calloc(uint16 MemSize)
{
  CheckHeap();
  return(calloc(MemSize,1));
}

void *KMEM__hugecalloc(uint32 MemSize)
{
  CheckHeap();
#if !__b__HUGE_MEMORY__
  if (MemSize>65535) return(NULL);
#endif
  return(calloc(MemSize,1));
}

void *KMEM__realloc(void *Ptr,uint16 NewSize)
{
  CheckHeap();
  return(realloc(Ptr,NewSize));
}

void *KMEM__hugerealloc(void *Ptr,uint32 NewSize)
{
  CheckHeap();
#if !__b__HUGE_MEMORY__
  if (NewSize>65535) return(NULL);
#endif
  return(realloc(Ptr,NewSize));
}

void KMEM__free(const void *Ptr)
{
  CheckHeap();
  free((void *)Ptr);
}
