#ifndef __h__SYSLIB_PDBASE__
#define __h__SYSLIB_PDBASE__

/*
  The basic structures used for the requests.
*/

typedef struct {
  upint8 Command;
} TNoParamCmd;

/*
  Standard error codes
*/
#define beREQLEN  -0x0100       /* Request too short */
#define beINVCMD  -0x0101       /* Invalid command in request */
#define beNOTSUP  -0x0102       /* Requested action not supported */
#define beINVAL   -0x0103       /* Invalid value in the request */
#define beUNKERR  -0x0104       /* Unknown server error */
#define beNOMEM   -0x0105       /* Server is out of memory */
#define beIO      -0x0106       /* Low level I/O error */
#define beFAULT   -0x0107       /* Attempt to I/O to/from invalid addr */
#define beINVDAT  -0x0108       /* Invalid data from device */
#define beRANGE   -0x0109       /* Argument out of range */
#define beTIMEOUT -0x010A       /* Device timeout error */
#define beCMDSEQ  -0x010B       /* Command sequence error */

/*
  POSIX error codes converted from the ANSI C standard library. These errors
  are returned by the calls on non-native-OSHS platforms. The native OSHS
  platforms will not use them. Some of the POSIX errors are located in the
  standard errors above.
*/
#define be2BIG        -0x0181      /* Argument list too big */
#define beACCESS      -0x0182      /* Permission denied */
#define beAGAIN       -0x0183      /* Resource temporarily unavailable */
#define beBADF        -0x0184      /* Bad file descriptor */
#define beBADMSG      -0x0185      /* Bad message */
#define beBUSY        -0x0186      /* Resource busy */
#define beCANCELLED   -0x0187      /* Operation cancelled */
#define beCHILD       -0x0188      /* No child process */
#define beDEADLK      -0x0189      /* Resource deadlock avoided */
#define beDOM         -0x018A      /* Domain error */
#define beEXIST       -0x018B      /* File already exists */
#define beFBIG        -0x018D      /* File too large */
#define beINPROGRESS  -0x018E      /* Operation in progress */
#define beINTR        -0x018F      /* Can't restart function call after intr */
#define beISDIR       -0x0192      /* Object is a directory */
#define beMFILE       -0x0193      /* Too many open files in process */
#define beMLINK       -0x0194      /* Too many links */
#define beMSGSIZE     -0x0195      /* Message buffer size not appropiate */
#define beNAMETOOLONG -0x0196      /* Filename too long */
#define beNFILE       -0x0197      /* Too many open files in system */
#define beNODEV       -0x0198      /* No such device */
#define beNOENT       -0x0199      /* No such file or directory */
#define beNOEXEC      -0x019A      /* Exec format error */
#define beNOLOCK      -0x019B      /* No locks available */
#define beNOSPC       -0x019D      /* No more free space on device */
#define beNOSYS       -0x019E      /* Function not implemented */
#define beNOTDIR      -0x019F      /* Object is not a directory */
#define beNOTEMPTY    -0x01A0      /* Directory not empty */
#define beNOTTY       -0x01A2      /* Inapropiate I/O control operation */
#define beNXIO        -0x01A3      /* No such device or adress */
#define bePERM        -0x01A4      /* Operation not permitted */
#define bePIPE        -0x01A5      /* Broken pipe */
#define beROFS        -0x01A7      /* Filesystem is read only */
#define beSPIPE       -0x01A8      /* Invalid seek operation */
#define beSRCH        -0x01A9      /* No such process */
#define beTIMEDOUT    -0x01AA      /* Operation timed out */
#define beXDEV        -0x01AB      /* Improper link */
/*
  Standard functions which must be provided by each server for each protocol.
*/

/* NO STANDARD FUNCTIOND DEFINED */

/*
  Standard protocols.
*/

#endif
