#ifndef __h__SYSLIB_PDDEV__
#define __h__SYSLIB_PDDEV__

/*
  OSHS device subsystem protocol.
*/

/*
  Device types
*/

typedef enum {
  /*
    Generic devices.
  */
  dtCharacter,
  dtBlock,
  /*
    Special hardware devices with their own protocols.
  */
  dtScreen,
  dtKeyboard,
  dtMouse,
  dtNetworkCard,
  /*
    Special devices that don't represent a real hardware.
  */
  dtInternet,
  /*
    Tag for an unknown device. Devices of this type are not opened but they
    are still reported by the system.
  */
  dtUnknown,
  /*
    It is guaranteed that the system never returns device of this type so
    this is available to indicate the end of the scan or similar conditions
    for example.
  */
  dtInvalid
} TDeviceType;

/*
  Device server commands
*/

#define cmdFindFirstDevice 0
#define cmdFindNextDevice 1

typedef struct {
  upint32 ID;
  TDeviceType Type;
  upint8 InfoString[65];
} TDevInfoReply;

#define cmdOpenDevice 2

typedef struct {
  upint8 Command;
  upint8 Device;
} TOpenDeviceCmd;

typedef struct {
  pint16 Handle;
} TOpenDeviceReply;

#endif
