#ifndef __h__SYSLIB_PDEXEC__
#define __h__SYSLIB_PDEXEC__

#define execeMANYARGS   -0x0500  /* Too many program arguments */
#define execeFORMAT     -0x0501  /* Executable file format error */
#define execeSUIDACC    -0x0502  /* Suid program execution denied */
#define execeTXTBSY     -0x0503  /* Program open for writing */
#define execeNONPROG    -0x0504  /* No program code to execute */
#define execeNONLIB     -0x0505  /* No library code to load */

/*
  The following error codes are returned in the reply packet. Additional info
  will be returned in the Info subfield of the reply packet.
*/

#define execeNOLIB       0x7F00  /* One or more libraries not loaded */

#define cmdCALL 0

typedef struct {
  upint8 Command;
  void *ArgList;
  void *EnvList;
} TExecCmd;

typedef struct {
  upint16 ExitCode;
  upint8 Info[MAX_MESSAGE_SIZE-2];
} TExecReply;

#define cmdLOAD 1

typedef struct {
  upint8 Command;
  char LibSpec[MAX_MESSAGE_SIZE-1];
} TLoadCmd;

#endif
