#include "defs.gh"
#include "types.h"
#include "strings.h"
#include "kernel.h"
#include "kernmsg.h"
#include "pdbase.h"
#include "pdfsys.h"
#include "diskmain.h"
#include "pdfileio.h"
#include "diskdata.h"
#include "pdgfxcon.h"
#include "errno.h"
#include "thread.h"
#include "scrvars.h"
#undef __t__windowed__
#define __t__windowed__ 0
#if __e__SCREEN_DRV__ == __v__SDL__
#undef __t__windowed__
#define __t__windowed__ 1
#elif __e__SCREEN_DRV__ == __v__X11__
#undef __t__windowed__
#define __t__windowed__ 1
#elif __e__SCREEN_DRV__ == __v__windows__
#undef __t__windowed__
#define __t__windowed__ 1
#endif
#if __t__windowed__
#include "gcwmain.h"
#endif
#undef __t__windowed__
#if __e__THREAD_DRV__ != __v__none__
#include "thrmain.h"
#endif
#include "traps.h"

#define __INTERFACE__
#include "screen.h"
#undef __INTERFACE__

#if __e__SCREEN_DRV__ == __v__none__
static int16 HandleScreen(void *Buf,int16 Size,void *Out,void *PD)
{
  return(beNOTSUP);
}
#endif

static int16 CloseScreen(void *fd)
{
#if __e__THREAD_DRV__ != __v__none__
  ThrRawLock(ScrLock);
#endif
  ScrBusy=false;
#if __e__THREAD_DRV__ != __v__none__
  ThrRawUnlock(ScrLock);
#endif
  return(0);
}

void CreateScreenHandle(void)
{
  void *Channel;
  void *Private;

#if __e__THREAD_DRV__ != __v__none__
  ScrLock=ThrRawCreateLock();
  if (ScrLock==NULL) Fatal("Unable to create screen lock");
#endif
  assert(CreateChannel(&Channel)==hndCONSOLE);
#if __e__SCREEN_DRV__ == __v__none__
  Private=NULL;
#else
  Private=CreatePrivateData();
#endif
  InitializeChannel(Channel,HandleScreen,Private,CloseScreen,DumbDestroy);
}
