#include "defs.gh"

#include <string.h>

#include "types.h"
#include "memory.h"

#define __INTERFACE__
#include "strtools.h"
#undef __INTERFACE__

#include "typesnd.h"

void *STR__strcpy(void *Dest,const void *Source)
{
  uint16 Len;

  Len=STR__strlen(Source);
  STR__memcpy(Dest,Source,Len+1);
  return((char *)Dest+Len);
}

void *STR__strncpy(void *Dest,const void *Source,uint16 Size)
{
  uint16 Len;
  uint16 CopyLen;

  Len=STR__strlen(Source);
  CopyLen=Len+1;
  if (Len>Size) {
    CopyLen=Size;
    Len=Size;
  }
  STR__memcpy(Dest,Source,CopyLen);
  return((char *)Dest+Len);
}

int16 STR__strcmp(const void *s1,const void *s2)
{
  return(strcmp(s1,s2));
}

int16 STR__strncmp(const void *s1,const void *s2,uint16 Size)
{
  return(strncmp(s1,s2,Size));
}

uint16 STR__strlen(const void *Str)
{
  return(strlen(Str));
}

void *STR__memcpy(void *Dest,const void *Src,uint16 Size)
{
  memcpy(Dest,Src,Size);
  return((char *)Dest+Size);
}

void *STR__memmove(void *Dest,const void *Src,uint16 Size)
{
  memmove(Dest,Src,Size);
  return((char *)Dest+Size);
}

void *STR__memset(void *Dest,uint16 Size,uint8 Byte)
{
  memset(Dest,Byte,Size);
  return((char *)Dest+Size);
}

int16 STR__memcmp(const void *Buf1,const void *Buf2,uint16 Size)
{
#if __b__MEMCMP_OK__
  return(memcmp(Buf1,Buf2,Size));
#else
  for( ; n; n--, a++, b++ ) {
    if( *a != *b ) {
      return (int16)(*(upint8*)a) - (int16)(*(upint8*)b);
    }
  }
  return 0;
#endif
}

void *STR__strchr(const void *Str,char c)
{
  return(strchr(Str,c));
}

void *STR__strrchr(const void *Str,char c)
{
  return(strrchr(Str,c));
}

char STR__upcase(char Ch)
{
  if ((Ch>='a') && (Ch<='z')) Ch-=(char)32;
  return(Ch);
}

void *STR__strtoupr(void *Dest,const void *Src)
{
  const char *S;
  char *D;
  char Ch;

  S=Src;
  D=Dest;
  do {
    Ch=*(S++);
    *(D++)=STR__upcase(Ch);
  } while (Ch);
  return(D-1);
}

void *STR__strntoupr(void *Dest,const void *Src,uint16 Size)
{
  const char *S;
  char *D;
  char Ch;

  S=Src;
  D=Dest;
  do {
    Size--;
    Ch=*(S++);
    *(D++)=STR__upcase(Ch);
  } while (Ch && (Size));
  return(D-(Ch=='\0'));
}

char STR__downcase(char Ch)
{
  if ((Ch>='A') && (Ch<='Z')) Ch+=(char)32;
  return(Ch);
}

void *STR__strtolwr(void *Dest,const void *Src)
{
  const char *S;
  char *D;
  char Ch;

  S=Src;
  D=Dest;
  do {
    Ch=*(S++);
    *(D++)=STR__downcase(Ch);
  } while (Ch);
  return(D-1);
}

void *STR__strntolwr(void *Dest,const void *Src,uint16 Size)
{
  const char *S;
  char *D;
  char Ch;

  S=Src;
  D=Dest;
  do {
    Size--;
    Ch=*(S++);
    *(D++)=STR__downcase(Ch);
  } while (Ch && (Size));
  return(D-(Ch=='\0'));
}
