#include "defs.gh"

#include "types.h"
#include "errno.h"
#include "traps.h"
#include "conio.h"
#include "strings.h"
#include "kernel.h"
#include "thread.h"

#define __INTERFACE__
#include "thrmain.h"
#undef __INTERFACE__

#if __e__THREAD_DRV__ == __v__SDL__
#include "thrsdl.h"
#elif __e__THREAD_DRV__ == __v__windows__
#include "thrwin.h"
#elif __e__THREAD_DRV__ == __v__pthread__
#include "thrpthr.h"
#endif

#define MAX_THREADS 1024
#define MAX_LOCKS 1024
#define MAX_CONDS 1024

void ThrRawReportError(const char *Msg)
{
  ThrReportError(Msg);
}

void *ThrRawCreateLock(void)
{
  return(ThrCreateLock());
}

void ThrRawDestroyLock(void *Lock)
{
  ThrDestroyLock(Lock);
}

void ThrRawLock(void *Lock)
{
  ThrLock(Lock);
}

void ThrRawUnlock(void *Lock)
{
  ThrUnlock(Lock);
}

void *ThrRawCreate(TMainFunction *MainFnc,void *Data)
{
  return(ThrCreate(MainFnc,Data));
}

int16 ThrRawWait(void *Thread)
{
  return(ThrWait(Thread));
}

bool ThrRawKill(void *Thread)
{
  return(ThrKill(Thread));
}

void ThrRawDestroyHandle(void *Handle)
{
  ThrDestroyHandle(Handle);
}

void *ThrRawCreateCond(void)
{
  return(ThrCreateCond());
}

void ThrRawSetCond(void *VV)
{
  ThrSetCond(VV);
}

void ThrRawResetCond(void *VV)
{
  ThrResetCond(VV);
}

void ThrRawWaitCond(void *VV)
{
  ThrWaitCond(VV);
}

void ThrRawDestroyCond(void *VV)
{
  ThrDestroyCond(VV);
}

void ThrRawInitThreads(void)
{
  ThrInitThreads();
}
