#ifndef __h__SYSLIB_TRAPS__
#define __h__SYSLIB_TRAPS__

#ifndef __DEBUG__
#define TrapUndefined(Msg)
#define ReportBug(Msg)
#else

#define TrapUndefined(Msg) {				\
  KINT__ReportUndefinedSituation(Msg);			\
  KINT__ReportFileAndLine(__FILE__,__LINE__);		\
}

#define ReportBug(Msg) {				\
  KINT__ReportDetectedBug(Msg);				\
  KINT__ReportFileAndLine(__FILE__,__LINE__);		\
}

#endif

#define InternalError(x) {				\
  KINT__ReportInternalError(x);				\
  KINT__ReportFileAndLine(__FILE__,__LINE__);		\
}

#if __t__SYSLIB_internals__

#ifdef __DEBUG__
#define Fatal(x) \
  {							\
    KINT__ReportFatalInitError(x);			\
    KINT__ReportFileAndLine(__FILE__,__LINE__);		\
  }
#else
#define Fatal(x) \
  {							\
    KINT__ReportFatalInitError(x);			\
  }
#endif

#endif

#endif
