/*
  Test: Bitfields and their values
*/

#include "types.h"
#include "conio.h"

bitsdef(TOpenMode,uint16)
  bitfield
    bitmask(oeOPEN,1<<5)
    bitmask(oeTRUNC,2<<5)
  endbitfield(oeACTION,oeOPEN|oeTRUNC)
  bitmask(onCREAT,1<<4)
  bitmask(oSYNC,1<<3)
  bitfield
    bitmask(oTEMP,0)
    bitmask(oRDONLY,1)
    bitmask(oWRONLY,2)
    bitmask(oRDWR,oRDONLY+oWRONLY)
  endbitfield(oACCESS,oTEMP|oRDONLY|oWRONLY|oRDWR)
  bitmask(oNOINHERIT,1<<7)
  bitmask(oAPPEND,256)
endbitsdef(TOpenMode)

bitsdef(TOverlappingBitfields,uint32)
  bitmask(ABitMask,1U<<31)
  bitmask(Overlapping,ABitMask)
endbitsdef(TOverlappingBitfields)

void NewLine(void)
{
  PrintSTDOUT("\n");
}

void Print(char *Msg)
{
  PrintSTDOUT(Msg);
  NewLine();
}

void DumpHex(uint32 Num)
{
  char Buf[9];
  char *Ptr;
  int16 Digit;

  Ptr=Buf+9;
  *(--Ptr)='\0';
  do {
    Digit=Num%16;
    if (Digit>9) Digit+=7;
    *(--Ptr)=Digit+'0';
    Num/=16;
  } while (Num>0);
  PrintSTDOUT(Ptr);
}

void Dump(char *Name,uint32 Num)
{
  PrintSTDOUT(Name);
  PrintSTDOUT("=");
  DumpHex(Num);
  NewLine();
}

int16 Main(void)
{
  TOpenMode Flags;
  TOverlappingBitfields Flags2;

  Dump("oeACTION",oeACTION);
  Dump("oeOPEN",oeOPEN);
  Dump("oeTRUNC",oeTRUNC);
  Dump("onCREAT",onCREAT);
  Dump("oSYNC",oSYNC);
  Dump("oACCESS",oACCESS);
  Dump("oTEMP",oTEMP);
  Dump("oRDONLY",oRDONLY);
  Dump("oWRONLY",oWRONLY);
  Dump("oRDWR",oRDWR);
  Dump("oNOINHERIT",oNOINHERIT);
  Dump("oAPPEND",oAPPEND);
  Flags=oeOPEN+onCREAT+oRDONLY+oAPPEND;
  Dump("Flags",Flags);
  Dump("Flags.oeACTION",get(Flags,oeACTION));
  Dump("Flags.oACCESS",get(Flags,oACCESS));
  Print("Setting oeACTION=oeTRUNC, oACCESS=oWRONLY and oSYNC=true");
  set(Flags,oeACTION,oeTRUNC);
  set(Flags,oACCESS,oWRONLY);
  set(Flags,oSYNC,true);
  Dump("Flags",Flags);
  Dump("Flags.oeACTION",get(Flags,oeACTION));
  Dump("Flags.oACCESS",get(Flags,oACCESS));
  Flags2=ABitMask;
  Dump("Flags2",Flags2);
  Dump("Flags2.ABitMask",get(Flags2,ABitMask));
  Dump("Flags2.Overlapping",get(Flags2,Overlapping));
  Print("Setting ABitMask=false");
  set(Flags2,ABitMask,false);
  Dump("Flags2",Flags2);
  Dump("Flags2.ABitMask",get(Flags2,ABitMask));
  Dump("Flags2.Overlapping",get(Flags2,Overlapping));
  if (false) set(Flags2,ABitMask,ABitMask);
  Print("Checking false conditional statement");
  Dump("Flags2",Flags2);
  Dump("Flags2.ABitMask",get(Flags2,ABitMask));
  Dump("Flags2.Overlapping",get(Flags2,Overlapping));
  
  return(0);
}
