/*
  Test: 64 bit computations

  Add-on to COMP32 test, which tests the 64 bit integers. Not all packages
  use 64 bit integers and they will perform well even if this test is
  failing. So this is the reason, why this test was separated from the
  others.
*/

#include "types.h"
#include "conio.h"

void Complain(const char *Msg)
{
  PrintSTDOUT(Msg);
  PrintSTDOUT("\n");
}

int16 Main(void)
{
  pint32 Num32A;
  pint32 Num32B;
  pint64 Num64A;
  pint64 Num64B;
  pint32 Res32;
  pint64 Res64;

  Num32A=0x12345678;
  Num32B=0x20304050;
  /*
    32 bit expression with 64 bit result.
  */
  Res64=(Num32A*Num32B);
  if (Res64!=0x249F931FC790580LL) Complain("32 bit ops; 64 bit result");
  /*
    64 bit expression with 32 bit result.
  */
  Num64A=Num32A;
  Num64B=Num32B;
  Res32=(Num64A*Num64B) / 0x1000000000LL;
  if (Res32!=0x249F93) Complain("64 bit ops with 32 bit result");
  /*
    The end.
  */
  return(0);
}
