/*
  Test: The "datablock" language extension
*/

#include "types.h"
#include "conio.h"
#include "strings.h"

void Procedure(void)
{
}

void OtherProcedure(void)
{
}

int16 Variable;
void *Ptr;

datablock(SomeDataBlock)
  streamstr "This is another datablock" endstream
enddatablock

datablock(PokusneData)
  streami8u 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20 endstream
  streami8u 100,101,102,103,104,105,106,107,108,109,110,111,112 endstream
  streami8 1,2,3,4,5,6,7,8,9,-1,-2,-3,-4,-5,-6,-7,-8,-9 endstream
  streami8 -101,-102,-103,-104,-105,-106,-107,-108,-109,5,6,7,8,9 endstream
  streami16u 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20 endstream
  streami16u 100,101,102,103,104,105,106,107,108,109,110,111,112 endstream
  streami16 1,2,3,4,5,6,7,8,9,-1,-2,-3,-4,-5,-6,-7,-8,-9 endstream
  streami16 -101,-102,-103,-104,-105,-106,-107,-108,-109,5,6,7,8,9 endstream
  streami32u 
    0l,1l,2l,3l,4l,5l,6l,7l,8l,9l,10l,11l,12l,13l,14l,15l,16l,17l,18l,19l,20l
  endstream
  streami32u
    100l,101l,102l,103l,104l,105l,106l,107l,108l,109l,110l,111l,112l
  endstream
  streami32
    1l,2l,3l,4l,5l,6l,7l,8l,9l,-1l,-2l,-3l,-4l,-5l,-6l,-7l,-8l,-9l
  endstream
  streami32
    -101l,-102l,-103l,-104l,-105l,-106l,-107l,-108l,-109l,5l,6l,7l,8l,9l
  endstream
  streamptr Procedure,OtherProcedure,&Variable endstream
  streamptr PokusneData() endstream
  streamptr SomeDataBlock() endstream
  streamstr "One","Two","Three" endstream
enddatablock

void ComplainMismatch(char *TypeName)
{
  PrintSTDOUT(": mismatch at stream");
  PrintSTDOUT(TypeName);
  PrintSTDOUT("\n");
}

void CheckI8u(uint8 Start,uint8 Stop)
{
  uint8 Value;

  for (;Start<=Stop;Start++) {
    Value=*((upint8 *)Ptr);
    if (Value!=Start) ComplainMismatch("i8u");
    Ptr+=1;
  }
}

void CheckI8(int8 Start,int8 Stop)
{
  int8 Value;

  for (;Start<=Stop;Start++) {
    Value=*((pint8 *)Ptr);
    if (Value!=Start) ComplainMismatch("i8");
    Ptr+=1;
  }
}

void CheckI8Down(int8 Start,int8 Stop)
{
  int8 Value;

  for (;Start>=Stop;Start--) {
    Value=*((pint8 *)Ptr);
    if (Value!=Start) ComplainMismatch("i8");
    Ptr+=1;
  }
}

void CheckI16u(uint16 Start,uint16 Stop)
{
  uint16 Value;

  for (;Start<=Stop;Start++) {
    Value=*((upint16 *)Ptr);
    if (Value!=Start) ComplainMismatch("i16u");
    Ptr+=2;
  }
}

void CheckI16(int16 Start,int16 Stop)
{
  int16 Value;

  for (;Start<=Stop;Start++) {
    Value=*((pint16 *)Ptr);
    if (Value!=Start) ComplainMismatch("i16");
    Ptr+=2;
  }
}

void CheckI16Down(int16 Start,int16 Stop)
{
  int16 Value;

  for (;Start>=Stop;Start--) {
    Value=*((pint16 *)Ptr);
    if (Value!=Start) ComplainMismatch("i16");
    Ptr+=2;
  }
}

void CheckI32u(uint32 Start,uint32 Stop)
{
  uint32 Value;

  for (;Start<=Stop;Start++) {
    Value=*((upint32 *)Ptr);
    if (Value!=Start) ComplainMismatch("i32u");
    Ptr+=4;
  }
}

void CheckI32(int32 Start,int32 Stop)
{
  int32 Value;

  for (;Start<=Stop;Start++) {
    Value=*((pint32 *)Ptr);
    if (Value!=Start) ComplainMismatch("i32");
    Ptr+=4;
  }
}

void CheckI32Down(int32 Start,int32 Stop)
{
  int32 Value;

  for (;Start>=Stop;Start--) {
    Value=*((pint32 *)Ptr);
    if (Value!=Start) ComplainMismatch("i32");
    Ptr+=4;
  }
}

void CheckPtr(void *P)
{
  void *Value;

  Value=*((void **)Ptr);
  if (Value!=P) ComplainMismatch("ptr");
  Ptr+=sizeof(Value);
}

void CheckStr(char *S)
{
  if (StrCmp(Ptr,S)) ComplainMismatch("str");
  Ptr+=StrLen(S)+1;
}

int16 Main(void)
{
  upint8 *Start;
  upint8 *End;

  Ptr=PokusneData();
  Start=Ptr;
  CheckI8u(0,20);
  CheckI8u(100,112);
  CheckI8(1,9);
  CheckI8Down(-1,-9);
  CheckI8Down(-101,-109);
  CheckI8(5,9);
  CheckI16u(0,20);
  CheckI16u(100,112);
  CheckI16(1,9);
  CheckI16Down(-1,-9);
  CheckI16Down(-101,-109);
  CheckI16(5,9);
  CheckI32u(0,20);
  CheckI32u(100,112);
  CheckI32(1,9);
  CheckI32Down(-1,-9);
  CheckI32Down(-101,-109);
  CheckI32(5,9);
  CheckPtr(Procedure);
  CheckPtr(OtherProcedure);
  CheckPtr(&Variable);
  CheckPtr(PokusneData());
  CheckPtr(SomeDataBlock());
  CheckStr("One");
  CheckStr("Two");
  CheckStr("Three");
  End=Ptr;
  if (End-Start!=datasize(PokusneData)) {
    ComplainMismatch("datablock size");
  }
  return(0);
}
