/*
  Test: Huge I/O using high performance file I/O
*/

#include "types.h"
#include "process.h"
#include "kernel.h"
#include "pdfsys.h"
#include "pdfileio.h"
#include "memory.h"
#include "conio.h"

#include "complain.i"
#include "fileio.i"

void Fatal(char *Msg)
{
  PrintSTDOUT(Msg);
  NewLine();
  PerformProgramHalting(255);
}

void CFatal(char *Msg)
{
  Complain(Msg);
  NewLine();
  PerformProgramHalting(255);
}

#define DATA_SIZE (64*1024*16)

int32 Seed;

int32 Rand(void)
{
  Seed=(Seed*1103515245+12345)&0x7FFFFFFF;
  return Seed;
}

int16 Main(void)
{
  void *Buffer;
  void *Buf2;
  pint32 *Ptr;
  pint32 *Ptr1;
  int16 fd;
  int32 Size;
  int32 i;
  int32 Count;

  Buffer=KMEM__hugemalloc(DATA_SIZE);
  Buf2=KMEM__hugemalloc(DATA_SIZE);
  if (Buffer==NULL || Buf2==NULL) Fatal("Out of memory");

  Count=DATA_SIZE/4;
  Ptr=Buffer;
  for (i=0;i<Count;i++) *(Ptr++)=Rand();
  Ptr=Buf2;
  for (i=0;i<Count;i++) *(Ptr++)=Rand();

  fd=NewOpen("T:/pokus.bin",oWRONLY+oeTRUNC+onCREAT);
  if (fd==-1) CFatal("Error creating test file");
  Size=NewWrite32(fd,Buffer,DATA_SIZE);
  if (Size!=DATA_SIZE) CFatal("Error writing data into the test file");
  if (!NewClose(fd)) CFatal("Error closing file after writing");

  fd=NewOpen("T:/pokus.bin",oRDONLY+oeOPEN);
  if (fd==-1) CFatal("Error opening just created test file");
  Size=NewRead32(fd,Buf2,DATA_SIZE);
  if (Size!=DATA_SIZE) CFatal("Error reading test data back");
  if (!NewClose(fd)) CFatal("Error closing file after reading");

  Ptr=Buffer;
  Ptr1=Buf2;
  for (i=0;i<Count;i++) {
    if (*(Ptr++)!=*(Ptr1++)) Fatal("Data error");
  }

  return(0);
}
