/*
  Test: Attempt to destroy a locked lock

  The system should report this as a bug in the program and abort the
  program.
*/

#include "types.h"
#include "kernel.h"
#include "thread.h"
#include "conio.h"
#include "process.h"
#include "time.h"

int16 TestLock;
int16 EndLock;

void Abort(const char *Msg)
{
  PrintSTDERR(Msg);
  PrintSTDERR("\n");
  PerformProgramHalting(255);
}

int16 Locker(void *Data)
{
  SYSLock(TestLock);
  PrintSTDOUT("Thread: TestLock locked or destroyed\n");
  SYSUnlock(EndLock);
  return(0);
}

int16 Main(void)
{
  TestLock=SYSCreateLock();
  EndLock=SYSCreateLock();
  if (TestLock<0 || EndLock<0) Abort("Unable to create a lock");
  SYSLock(TestLock);
  SYSLock(EndLock);
  if (SYSCreateNewThread(Locker,NULL)<0) Abort("Unable to create thread");
  PrintSTDOUT("Program: Waiting for 0.1 second\n");
  DelayThread(100000);
  SYSDestroyLock(TestLock);
  PrintSTDOUT("Program: TestLock destroyed\n");
  SYSLock(EndLock);
  return(0);
}
