/*
  Test: Unlocking a lock acquired by another thread

  OSHS specifically allows to do that.
*/

#include "types.h"
#include "kernel.h"
#include "thread.h"
#include "conio.h"
#include "process.h"
#include "time.h"

int16 TestLock;

void Abort(const char *Msg)
{
  PrintSTDERR(Msg);
  PrintSTDERR("\n");
  PerformProgramHalting(255);
}

int16 Unlocker(void *Data)
{
  SYSUnlock(TestLock);
  return(0);
}

int16 Main(void)
{
  TestLock=SYSCreateLock();
  if (TestLock<0) Abort("Unable to create a lock");
  SYSLock(TestLock);
  if (SYSCreateNewThread(Unlocker,NULL)==-1) Abort("Unable to create thread");
  DelayThread(100000);
  SYSLock(TestLock);
  SYSUnlock(TestLock);
  SYSDestroyLock(TestLock);
  return(0);
}
