/*
  Test: Integer type sizes
*/

#include "types.h"
#include "conio.h"

void Complain(const char *Msg)
{
  PrintSTDOUT(Msg);
  PrintSTDOUT("\n");
}

int16 Main(void)
{
  /*
    Check if "p" integer types have the exact size.
  */
  if (sizeof(pint8)!=1) Complain("pint8 size bad");
  if (sizeof(pint16)!=2) Complain("pint16 size bad");
  if (sizeof(pint32)!=4) Complain("pint32 size bad");
  if (sizeof(pint64)!=8) Complain("pint64 size bad");
  if (sizeof(upint8)!=1) Complain("upint8 size bad");
  if (sizeof(upint16)!=2) Complain("upint16 size bad");
  if (sizeof(upint32)!=4) Complain("upint32 size bad");
  if (sizeof(upint64)!=8) Complain("upint64 size bad");
  /*
    Check if "non-p" integer types have correct size.
  */
  if (sizeof(int8)<1) Complain("pint8 size bad");
  if (sizeof(int16)<2) Complain("pint16 size bad");
  if (sizeof(int32)<4) Complain("pint32 size bad");
  if (sizeof(int64)<8) Complain("pint64 size bad");
  if (sizeof(uint8)<1) Complain("upint8 size bad");
  if (sizeof(uint16)<2) Complain("upint16 size bad");
  if (sizeof(uint32)<4) Complain("upint32 size bad");
  if (sizeof(uint64)<8) Complain("upint64 size bad");

  return(0);
}
