/*
  This hack is extremely ugly but a) it works, b) is easy to program and c)
  this is only a private utility used during the SYSLIB build.

  This will not work when the InitDisks() does not produce identical results
  for the Z: drive when called twice but I currently don't have such thing.
*/

#include <defs.gh>
#include <types.h>
#include <kernel.h>
#include <kernmsg.h>
#include <pdbase.h>
#include <pdfsys.h>
#include <pdfileio.h>
#include <diskdata.h>
#include <disklett.h>
#include <ltwd.h>
#include <env.h>
#include <strings.h>
#include <process.h>

static int16 OutFile;
static int16 ErrNo;
typedef struct {
  TDirItem I;
  TFileInfo S;
} TDirItemInfo;

static TDirItem *CurDir;

static int16 OpenDir(const char *FileName)
{
  TOpenCmd C;
  TOpenReply R;
  char *Ptr;
  upint32 Sender;

  C.Command=cmdOPENDIR;
  C.Mode=oeOPEN+oRDONLY;
  Ptr=StrNCpy(C.FileSpec,FileName,MAX_FILESPEC_SIZE+1);
  ErrNo=fseNAMELEN;
  if (Ptr-C.FileSpec>MAX_FILESPEC_SIZE) return(-1);
  ErrNo=KCALL__SEND(hndROOTFS,&C,sizeof(C));
  if (ErrNo<0) return(-1);
  ErrNo=KCALL__RECV(hndROOTFS,&R,sizeof(R),&Sender);
  if (ErrNo<sizeof(R)) {
    if (ErrNo>=0) ErrNo=beUNKERR;
    return(-1);
  }
  return(R.Handle);
}

static int16 Read(int16 fd,void *Buf,uint16 Size)
{
  TReadAndSendCmd C;
  TDataCmd R;
  upint32 Sender;
  uint16 ReadSize;
  uint16 TotalReadSize;

  C.Command=cmdREADANDSEND;
  C.Size=Size;
  ErrNo=KCALL__SEND(fd,&C,sizeof(C));
  if (ErrNo<0) return(-1);
  TotalReadSize=0;
  while (true) {
    ErrNo=KCALL__RECV(fd,&R,sizeof(R),&Sender);
    if (ErrNo<0) return(-1);
    if (ErrNo==0) break;
    ReadSize=ErrNo-1;
    TotalReadSize+=ReadSize;
    ErrNo=beUNKERR;
    if (R.Command!=cmdDATA) return(-1);
    if (ReadSize>Size) return(-1);
    MemCpy(Buf,R.Data,ReadSize);
    Buf+=ReadSize;
    Size-=ReadSize;
  }
  return(TotalReadSize);
}

static bool IStat(uint32 ItemID,TFileInfo *Info)
{
  TIStatCmd C;
  upint32 Sender;

  C.Command=cmdISTAT;
  C.ID=ItemID;
  ErrNo=KCALL__SEND(hndROOTFS,&C,sizeof(C));
  if (ErrNo<0) return(false);
  ErrNo=KCALL__RECV(hndROOTFS,Info,sizeof(*Info),&Sender);
  if (ErrNo!=sizeof(*Info)) ErrNo=beUNKERR;
  return(ErrNo==sizeof(*Info));
}

static bool ReadDir(int16 dd,TDirItemInfo *Buf)
{
  int32 Size;
  int16 ErrNo;

  Size=Read(dd,Buf,sizeof(Buf->I));
  if (Size==0) {
    Size=sizeof(Buf->I);
    Buf->I.ID=-1;
  }
  ErrNo=beUNKERR;
  if (Size!=sizeof(Buf->I)) return(false);
  ErrNo=IStat(Buf->I.ID,&Buf->S);
  if (ErrNo>0) ErrNo=0;
  return(ErrNo==0);
}

static void Write(int16 fd,const char *Buf)
{
  TDataCmd C;
  TDataCmd R;
  upint8 *Ptr;
  upint32 Sender;
  uint16 SizeToWrite;

  C.Command=cmdDATA;
  Ptr=StrNCpy(C.Data,Buf,MAX_MESSAGE_SIZE-1);
  SizeToWrite=Ptr-C.Data;
  assert(SizeToWrite<MAX_MESSAGE_SIZE-1);
  ErrNo=KCALL__SEND(fd,&C,SizeToWrite+1);
  if (ErrNo<0) return;
  ErrNo=KCALL__RECV(fd,&R,sizeof(R),&Sender);
}

static void WriteNum(int16 fd,uint32 Num)
{
  char NumStr[11];
  char *Ptr;

  Ptr=NumStr+11;
  *(--Ptr)='\0';
  do {
    *(--Ptr)=(Num%10)+'0';
    Num/=10;
  } while (Num>0);
  Write(fd,Ptr);
}

static void ReportError(const char *Msg)
{
  int16 Err;
  char NumStr[5];
  char *Ptr;
  const char *Hex;

  Err=ErrNo;
  Write(hndSTDERR,Msg);
  if (Err<0) {
    Write(hndSTDERR,"\nSystem said: -0x");
    Err=-Err;
    Hex="0123456789ABCDEF";
    Ptr=NumStr+5;
    *(--Ptr)='\0';
    while (Ptr>NumStr) {
      *(--Ptr)=Hex[Err%16];
      Err/=16;
    }
    Write(hndSTDERR,NumStr);
  }
  Write(hndSTDERR,"\n");
  PerformProgramHalting(1);
}

static int16 OpenOutputFile(void)
{
  TOpenCmd C;
  TOpenReply R;
  upint32 Sender;

  C.Command=cmdOPENFILE;
  C.Mode=oeTRUNC+onCREAT+oWRONLY;
  StrCpy(C.FileSpec,"../filelist.ne1");
  ErrNo=KCALL__SEND(hndROOTFS,&C,sizeof(C));
  if (ErrNo<0) return(-1);
  ErrNo=KCALL__RECV(hndROOTFS,&R,sizeof(R),&Sender);
  if (ErrNo<sizeof(R)) {
    if (ErrNo>=0) ErrNo=beUNKERR;
    return(-1);
  }
  return(R.Handle);
}

void CheckAndOutputFile(const TDirItemInfo *Buf, const char *Ext)
{
  int16 ExtLen;
  int16 Len;

  if ((Buf->S.Attr&fmTYPE) != fmREGULAR) return;
  ExtLen=StrLen(Ext);
  Len=StrLen(Buf->I.Name);
  if (Len<4) return;
  if (StrCmp(Buf->I.Name+Len-ExtLen,Ext)!=0) return;
  if (CurDir!=NULL) {
    Write(OutFile,CurDir->Name);
    Write(OutFile,"/");
  }
  Write(OutFile,Buf->I.Name);
  Write(OutFile,"\t");
  WriteNum(OutFile,Buf->S.Size);
  Write(OutFile,"\t");
  WriteNum(OutFile,Buf->S.CreatedTime);
  Write(OutFile,"\t");
  WriteNum(OutFile,Buf->S.ModifiedTime);
  Write(OutFile,"\n");
}

static void WriteCurDirName(void)
{
  Write(hndSTDERR,CurDir->Name);
  Write(hndSTDERR,": ");
}

void AnalyzeDirectory(TDirItemInfo *Dir,const char *Ext)
{
  int16 SubDir;
  TDirItemInfo Buf;

  CurDir=&Dir->I;
  SubDir=OpenDir(CurDir->Name);
  if (SubDir<0) {
    WriteCurDirName();
    ReportError("Unable to open subdirectory");
  }
  while (true) {
    if (!ReadDir(SubDir,&Buf)) {
      WriteCurDirName();
      ReportError("Error reading subdirectorry");
    }
    if (Buf.I.ID==-1) break;
    CheckAndOutputFile(&Buf,Ext);
  }
  KCALL__CLOSE(SubDir);
  CurDir=NULL;
}

void GatherM4(void)
{
  int16 MainDir;
  TDirItemInfo Buf;

  OutFile=OpenOutputFile();
  if (OutFile<0) ReportError("Unable to create output file");
  StrCpy(Buf.I.Name,"..");
  AnalyzeDirectory(&Buf,".sh");
  MainDir=OpenDir(".");
  if (MainDir<0) ReportError("Unable to open current directory");
  CurDir=NULL;
  while (true) {
    if (!ReadDir(MainDir,&Buf)) {
      ReportError("Error reading current directorry");
    }
    if (Buf.I.ID==-1) break;
    CheckAndOutputFile(&Buf,".m4");
    if ((Buf.S.Attr&fmTYPE) == fmDIRECTORY) AnalyzeDirectory(&Buf,".m4");
  }
  KCALL__CLOSE(MainDir);
}

#include <typesnd.h>
#include <stdio.h>

static void GetCBDir(void)
{
  TRootStatus R;
  char *Ptr;
  char *Beg;
  bool WasEnd;

  InitDisks(&R);
  Ptr=R.Drives[25].Dir;
  Beg=Ptr;
  WasEnd=(*Ptr=='\0');
  while (!WasEnd) {
    Ptr++;
    WasEnd=(*Ptr=='\0');
    if (*Ptr=='/' || *Ptr=='\\' || WasEnd) {
      *Ptr='\0';
      printf("%s ",Beg);
      *Ptr='/';
      Beg=Ptr;
    }
  }
}

static void GetIDir(void)
{
  char Buffer[1024];
  char *Ptr;

  Ptr=PutInternalDirSpec(NULL,Buffer);
  if (Ptr==Buffer+1) return;
  if (*(Ptr-1)=='/' || *(Ptr-1)=='\\') Ptr--;
  *Ptr='\0';
  printf("%s",Buffer);
}

static void GetLibs(void)
{
  printf("%s",__x__ADDON_LIBS__);
}

int Main(void)
{
  const char *Arg;

  Arg=GetArg(0);
  if (Arg!=NULL) {
    if (Arg[0]=='C' && Arg[1]=='B' && Arg[2]=='\0') {
      GetCBDir();
    } else if (Arg[0]=='I' && Arg[1]=='\0') {
      GetIDir();
    } else if (Arg[0]=='L' && Arg[1]=='\0') {
      GetLibs();
    }
  } else {
    GatherM4();
  }
  return(0);
}
